<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Directory.Modules.Contacts" Codebehind="Contacts.ascx.cs" %>
<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="../../Modules/BlockHeader.ascx" %>
<%@ register TagPrefix="dg" namespace="Mediachase.UI.Web.Modules.DGExtension" Assembly="Mediachase.UI.Web" %>
<style type="text/css">
	.simple{
		width: 25px;
		background-color:#F4F4F4;
		border:1px solid #A0A0A0;
		text-align:center;
		vertical-align:center;
		height:20px;
	}
	.simpleselected{
		width: 25px;
		background-color:#DADADA;
		border:1px solid #C0C0C0;
		text-align:center;
		vertical-align:center;
		height:20px;
		font-weight:bold;
	}
	.simplehover{
		width: 25px;
		background-color:#FFEEEE;
		border:1px solid #C0C0C0;
		text-align:center;
		vertical-align:center;
		height:20px;
		cursor:pointer;
		color: red;
	}
</style>
<script type="text/javascript">
	function Over(obj)
	{
		if(obj)
		{
			if(obj.className == "simple")
				obj.className = "simplehover";
		}
	}
	
	function Out(obj)
	{
		if(obj)
		{
			if(obj.className == "simplehover")
				obj.className = "simple";
		}
	}
	function DoFilter(sValue)
	{
		document.forms[0].<%=hidFilter.ClientID %>.value = sValue;
		<%=Page.GetPostBackClientEvent(lbFilter,"") %>
	}
</script>
<table class="ibn-propertysheet ibn-stylebox2" cellspacing="0" cellpadding="0" width="100%" border="0">
	<tr>
		<td><ibn:blockheader id="secHeader" runat="server" /></td>
	</tr>
	<tr>
		<td class="ibn-alternating ibn-navline" style="padding:7px;" id="tdFilter" runat="server">
			
		</td>
	</tr>
	<tr>
		<td>
			<dg:DataGridExtended Runat="server" ID="dgMain" AutoGenerateColumns="False" 
			AllowPaging="True" pagesize="10" AllowSorting="True" cellpadding="3" gridlines="Horizontal" 
			CellSpacing="0" borderwidth="0px" Width="100%" ShowHeader="True">
				<HeaderStyle CssClass="ibn-vh2"></HeaderStyle>
				<Columns>
					<asp:BoundColumn Visible="False" DataField="ContactId" ReadOnly="True"></asp:BoundColumn>
					<asp:TemplateColumn SortExpression="ContactName">
						<ItemStyle CssClass="ibn-vb2"></ItemStyle>
						<ItemTemplate>
							<a href='<%# "javascript:OpenPopUpWindow(\"../Directory/ContactEdit.aspx?ContactId=" + DataBinder.Eval(Container.DataItem, "ContactId").ToString() + "\",800, 600)"%>'>
								<%# DataBinder.Eval(Container.DataItem, "ContactName") %>
							</a>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="OrgNameLink" ItemStyle-CssClass="ibn-vb2" SortExpression="OrgName"></asp:BoundColumn>
					<asp:BoundColumn DataField="Emails" ItemStyle-CssClass="ibn-vb2" SortExpression="Emails"></asp:BoundColumn>
					<asp:BoundColumn DataField="Phones" ItemStyle-CssClass="ibn-vb2" SortExpression="Phones"></asp:BoundColumn>
					<asp:TemplateColumn>
						<HeaderStyle HorizontalAlign="Right" Width="25px" CssClass="ibn-vh-right"></HeaderStyle>
						<ItemStyle Width="25px" CssClass="ibn-vb2"></ItemStyle>
						<ItemTemplate>
							<asp:imagebutton id="ibDelete" runat="server" borderwidth="0" width="16" height="16" imageurl="../../layouts/images/DELETE.GIF" causesvalidation="False" CommandName="Delete" visible=<%# CanDelete((int)DataBinder.Eval(Container.DataItem, "ContactId")) %> CommandArgument='<%# DataBinder.Eval(Container.DataItem, "ContactId") %>'></asp:imagebutton>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</dg:DataGridExtended>
		</td>
	</tr>
</table>
<asp:LinkButton ID="lbFilter" Runat="server" Visible="False" />
<input type="hidden" runat="server" id="hidFilter" />