<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ForumControl.ascx.cs" Inherits="Mediachase.UI.Web.Modules.ForumControls.ForumControl" %>
<%@ Register TagPrefix="ibn" Namespace="Mediachase.IBN.Business" Assembly="Mediachase.IBN.Business" %>
<%@ Register TagPrefix="ibn" Namespace="Mediachase.UI.Web.Modules.ForumControls" Assembly="Mediachase.UI.Web" %>
<%@ Register TagPrefix="ComponentArt" Namespace="ComponentArt.Web.UI" Assembly="ComponentArt.Web.UI" %>

<ComponentArt:Menu id="caMenu" 
	Orientation="Horizontal"
	CssClass="BTopGroup"
	DefaultGroupCssClass="BMenuGroup"
	DefaultItemLookID="DefaultItemLook"
	DefaultGroupItemSpacing="1"
	EnableViewState="false"
	ExpandDelay="100"
	ExpandOnClick="true"
	ClientScriptLocation="~/Scripts/componentart_webui_client/"
	runat="server">
<ItemLooks>
	<ComponentArt:ItemLook LookID="TopItemLook" CssClass="BTopMenuItem" HoverCssClass="BTopMenuItemHover" ExpandedCssClass="BTopMenuItemExpanded" LabelPaddingLeft="10" LabelPaddingRight="10" LabelPaddingTop="2" LabelPaddingBottom="2" />
	<ComponentArt:ItemLook LookID="DefaultItemLook" CssClass="BMenuItem" HoverCssClass="BMenuItemHover" ExpandedCssClass="BMenuItemHover" LeftIconWidth="20" LeftIconHeight="18" LabelPaddingLeft="10" LabelPaddingRight="10" LabelPaddingTop="3" LabelPaddingBottom="4" />
	<ComponentArt:ItemLook LookID="BreakItem" CssClass="BMenuBreak" />
</ItemLooks>
</ComponentArt:Menu>
<asp:LinkButton ID="lbAction" Runat="server" Visible="True" OnClick="lbAction_Click"></asp:LinkButton>
			
<ibn:ForumGrid runat="server" ID="grdMain" CommandManagerID="cmanager" ShowHeader="false" AllowPaging="true" PageSize="10" OnPageIndexChanged="grdMain_PageIndexChanged" OnPageIndexChanging="grdMain_PageIndexChanging" OnRowCommand="grdMain_RowCommand" PagerStyle-HorizontalAlign="Right"></ibn:ForumGrid>
<ibn:BaseCommandManager ID="cmanager" runat="server" />
