<%@ Control Language="C#" AutoEventWireup="true" ClassName="ForumNode_default" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="Mediachase.Forum.FileStorage" %>
<%@ Reference Control="~/Modules/ForumControls/NodeActionsControl.ascx" %>
<%@ Reference Control="~/Modules/ForumControls/ForumNodeFiles.ascx" %>
<%@ Register TagPrefix="ibn" TagName="NodeActionsControl" src="..\ForumControls\NodeActionsControl.ascx" %>
<%@ Register TagPrefix="ibn" TagName="ForumNodeFiles" src="..\ForumControls\ForumNodeFiles.ascx" %>
<%@ Register TagPrefix="ibn" Assembly="Mediachase.UI.Web" Namespace="Mediachase.UI.Web.Modules.ForumControls" %>

<div class="nodeItem">
	<table class="tbl nodeHead">
		<tr>
			<td class="user">
				<ibn:IbnUser UserId='<%# Eval("Creator") %>' runat="server" ID="ucCreator" />
			</td>
			<td>
				<ibn:NodeEvents runat="server" ID="ucNodeEvents" NodeValue='<%# DataBinder.GetDataItem(Container)%>'></ibn:NodeEvents>
			</td>
			<td class="date right">
				<%# ((DateTime)Eval("Created")).ToShortDateString() %>
				<%# ((DateTime)Eval("Created")).ToShortTimeString() %>
			</td>
		</tr>
	</table>

	<div style='<%# ((List<FileStreamInfo>)Eval("Attachments")).Count > 0 || Eval("Body").ToString().Length > 0 ? "display:block" : "display:none" %>'>
		<table class="tbl">
			<tr>
				<td class="nodeIcon" align="center">
					<ibn:NodeIcon runat="server" ID="ucNodeIcon" NodeValue='<%# DataBinder.GetDataItem(Container)%>'/>	
					<ibn:NodeMarks CssClass="nodeMarks" runat="server" ID="ucNodeNarks" NodeValue='<%# DataBinder.GetDataItem(Container)%>' Delimeter="<br />"></ibn:NodeMarks>
				</td>
				<td>
					<div class="nodeBody">
						<ibn:NodeBodyControl NodeValue='<%# DataBinder.GetDataItem(Container)%>' runat="server" ID="ucBody" MaxLength="400" />
					</div>
					<div class="nodeFiles">
						<ibn:ForumNodeFiles Attachments='<%# Eval("Attachments")%>' Delimeter=" &nbsp; " ID="ucForumNodeFiles" runat="server" />
					</div>
				</td>
			</tr>
		</table>
	</div>
	
	<div class="nodeFoot">
		<ibn:NodeActionsControl NodeValue='<%# DataBinder.GetDataItem(Container)%>' ModeValue="Image" ID="ucActions" runat="server" Visible="true" />
	</div>
</div>
