<%@ Reference Control="~/Modules/Separator1.ascx" %>
<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Projects.Modules.LatestAllUpdates" Codebehind="LatestAllUpdates.ascx.cs" %>
<%@ Register TagPrefix="ibn" TagName="sep" src="..\..\Modules\Separator1.ascx"%>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="..\..\Modules\BlockHeader.ascx"%>
<TABLE class="ibn-stylebox" cellSpacing="0" cellPadding="0" width="100%" border="0">
	<tr>
		<td>
			<ibn:blockheader id="tbHeader" title="" runat="server"></ibn:blockheader>
		</td>
	</tr>
	<tr>
		<td>
			<ibn:sep id="sep2" title="" runat="server"></ibn:sep>
			<asp:panel id="Pan2" Runat="server">
				<asp:DataGrid id="dgIncidents" Runat="server" EnableViewState="False" PagerStyle-Mode="NumericPages" AutoGenerateColumns="False" AllowPaging="true" AllowSorting="False" CellSpacing="0" PageSize="5" PagerStyle-Visible="true" PagerStyle-HorizontalAlign="Right" Width="100%" GridLines="None" borderwidth="0px" cellpadding="2" ShowHeader="true">
					<ItemStyle CssClass="ibn-propertysheet"></ItemStyle>
					<HeaderStyle CssClass="ibn-vh2"></HeaderStyle>
					<PagerStyle CssClass="text ibn-TPHeader" HorizontalAlign="Right"></PagerStyle>
					<Columns>
						<asp:TemplateColumn>
							<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetIncidentTitle 
									(
										(int)DataBinder.Eval(Container.DataItem, "IncidentId")
									)
								%>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn ItemStyle-Width="180px" ItemStyle-VerticalAlign="Top">
						<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetUserStatus
									(
										(int)DataBinder.Eval(Container.DataItem, "LastEditorId")
									)
								%>
								</a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataField="LastSavedDate" ItemStyle-Width="120" DataFormatString="{0:d}"></asp:BoundColumn>
					</Columns>
				</asp:DataGrid>
			</asp:panel>
			<ibn:sep id="sep3" title="" runat="server"></ibn:sep>
			<asp:panel id="Pan3" Runat="server">
				<asp:DataGrid id="dgDocuments" Runat="server" EnableViewState="False" PagerStyle-Mode="NumericPages" AutoGenerateColumns="False" AllowPaging="true" AllowSorting="False" CellSpacing="0" PageSize="5" PagerStyle-Visible="true" PagerStyle-HorizontalAlign="Right" Width="100%" GridLines="None" borderwidth="0px" cellpadding="2" ShowHeader="true">
					<ItemStyle CssClass="ibn-propertysheet"></ItemStyle>
					<HeaderStyle CssClass="ibn-vh2"></HeaderStyle>
					<PagerStyle CssClass="text ibn-TPHeader" HorizontalAlign="Right"></PagerStyle>
					<Columns>
						<asp:TemplateColumn>
							<ItemTemplate>
								<a href="../Documents/DocumentView.aspx?DocumentId=<%# DataBinder.Eval(Container.DataItem, "DocumentId")%>"><%# DataBinder.Eval(Container.DataItem, "Title")%></a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataField="LastSavedDate" ItemStyle-Width="120" DataFormatString="{0:d}"></asp:BoundColumn>
					</Columns>
				</asp:DataGrid>
			</asp:panel>
			<ibn:sep id="sep4" title="" runat="server"></ibn:sep>
			<asp:panel id="Pan4" Runat="server">
				<asp:DataGrid id="dgEvents" Runat="server" EnableViewState="False" PagerStyle-Mode="NumericPages" AutoGenerateColumns="False" AllowPaging="true" AllowSorting="False" CellSpacing="0" PageSize="5" PagerStyle-Visible="true" PagerStyle-HorizontalAlign="Right" Width="100%" GridLines="None" borderwidth="0px" cellpadding="2" ShowHeader="true">
					<ItemStyle CssClass="ibn-propertysheet"></ItemStyle>
					<HeaderStyle CssClass="ibn-vh2"></HeaderStyle>
					<PagerStyle CssClass="text ibn-TPHeader" HorizontalAlign="Right"></PagerStyle>
					<Columns>
						<asp:TemplateColumn>
							<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetEventTitle 
									(
										(int)DataBinder.Eval(Container.DataItem, "EventId"),
										(int)DataBinder.Eval(Container.DataItem, "StateId"),
										(string)DataBinder.Eval(Container.DataItem, "Title")
									)
								%>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn ItemStyle-Width="180px" ItemStyle-VerticalAlign="Top">
						<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetUserStatus
									(
										(int)DataBinder.Eval(Container.DataItem, "LastEditorId")
									)
								%>
								</a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataField="LastSavedDate" ItemStyle-Width="120" DataFormatString="{0:d}"></asp:BoundColumn>
					</Columns>
				</asp:DataGrid>
			</asp:panel>
			<ibn:sep id="sep5" title="" runat="server"></ibn:sep>
			<asp:panel id="Pan5" Runat="server">
				<asp:DataGrid id="dgTasks" Runat="server" EnableViewState="False" PagerStyle-Mode="NumericPages" AutoGenerateColumns="False" AllowPaging="true" AllowSorting="False" CellSpacing="0" PageSize="5" PagerStyle-Visible="true" PagerStyle-HorizontalAlign="Right" Width="100%" GridLines="None" borderwidth="0px" cellpadding="2" ShowHeader="true">
					<ItemStyle CssClass="ibn-propertysheet"></ItemStyle>
					<HeaderStyle CssClass="ibn-vh2"></HeaderStyle>
					<PagerStyle CssClass="text ibn-TPHeader" HorizontalAlign="Right"></PagerStyle>
					<Columns>
						<asp:TemplateColumn>
							<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetTaskToDoLink 
									(
										(int)DataBinder.Eval(Container.DataItem, "ItemId"),
										(int)DataBinder.Eval(Container.DataItem, "IsToDo"),
										DataBinder.Eval(Container.DataItem, "Title").ToString(),
										(int)DataBinder.Eval(Container.DataItem, "StateId")
									)
								%>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn ItemStyle-Width="180px" ItemStyle-VerticalAlign="Top">
						<ItemTemplate>
								<%# Mediachase.UI.Web.Util.CommonHelper.GetUserStatus
									(
										(int)DataBinder.Eval(Container.DataItem, "LastEditorId")
									)
								%>
								</a>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataField="LastSavedDate" ItemStyle-Width="120" DataFormatString="{0:d}"></asp:BoundColumn>
					</Columns>
				</asp:DataGrid>
			</asp:panel>
		</td>
	</tr>
</TABLE>
