<%@ Reference Control="~/Modules/DateTimeClientControl.ascx" %>
<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Reference Control="~/Modules/BlockHeaderLightWithMenu.ascx" %>
<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Directory.Modules.ContactEdit" Codebehind="ContactEdit.ascx.cs" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="..\..\Modules\BlockHeader.ascx" %>
<%@ register TagPrefix="btn" namespace="Mediachase.UI.Web.Modules" Assembly="Mediachase.UI.Web" %>
<%@ Register TagPrefix="ibn" TagName="DTCC" src="..\..\Modules\DateTimeClientControl.ascx" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeaderLight" src="../../Modules/BlockHeaderLightWithMenu.ascx" %>
<script type="text/javascript" language="javascript">
function SetFullName()
{
	var txtFullName = document.getElementById('<%= txtFullName.ClientID%>');
	var txtFamilyName = document.getElementById('<%= txtFamilyName.ClientID%>');
	var txtGivenName = document.getElementById('<%= txtGivenName.ClientID%>');
	var txtMiddleName = document.getElementById('<%= txtMiddleName.ClientID%>');
	
	if (txtFamilyName == null || txtGivenName == null || txtMiddleName == null || txtFullName == null)
		return;
	
	txtFullName.value = txtFamilyName.value;
	
	if (txtGivenName.value != "")
	 txtFullName.value +=  " " + txtGivenName.value.substr(0, 1) + ".";
	 
	if (txtMiddleName.value != "")
	 txtFullName.value +=  " " + txtMiddleName.value.substr(0, 1) + ".";
}

function FillOrganization()
{
	var ddlOrganization = document.getElementById('<%= ddlOrganization.ClientID%>');
	var txtOrganizationName = document.getElementById('<%= txtOrganizationName.ClientID%>');
	
	if (ddlOrganization == null || txtOrganizationName == null)
		return;
		
	
	if (ddlOrganization.value != "-1")
	{
		txtOrganizationName.value = ddlOrganization.options[ddlOrganization.selectedIndex].text;
		txtOrganizationName.disabled = true;
	}
	else
	{
		txtOrganizationName.disabled = false;
	}
}
</script>


<table class="ibn-propertysheet" cellSpacing="0" cellPadding="0" width="100%" border="0">
	<tr>
		<td colspan="2"><ibn:blockheader id="secHeader" runat="server" /></td>
	</tr>
	<tr>
		<td style="padding:5px" width="50%" valign=top>
			<ibn:BlockHeaderLight id="hdrBasicInfo" runat="server" />
				<table class="ibn-stylebox-light text" cellSpacing="0" cellPadding="5" border="0" width="100%" style="table-layout:fixed">
					<tr>
						<td width="120px"><b><%= LocRM.GetString("FamilyName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtFamilyName" Width="230" MaxLength="50" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("GivenName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtGivenName" Width="230" MaxLength="50" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("MiddleName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtMiddleName" Width="230" MaxLength="50" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("FullName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtFullName" Width="230" MaxLength="250" CssClass="text"></asp:TextBox>
							<asp:RequiredFieldValidator id="txtFullNameRFValidator" runat="server" ErrorMessage="*" ControlToValidate="txtFullName"	Display="Dynamic"></asp:RequiredFieldValidator>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("NickName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtNickName" Width="230" MaxLength="50" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("Title")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtTitle" Width="230" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("Role")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtRole" Width="230" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("Gender")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtGender" Width="120" MaxLength="15" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("Birthday")%>:</b></td>
						<td>
							<ibn:DTCC id="dtcBirthday" Path_Img="../Layouts/Images/" Path_JS="../Scripts/" File_JS="mcCalendScript.js" SelectionDateType="Day" ViewStartDate="False" RequiredField="False" runat="server" View2Rows="True" btnImgResetVisible="True"></ibn:DTCC>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("Url")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtUrl" Width="230" MaxLength="255" CssClass="text"></asp:TextBox>
							<asp:regularexpressionvalidator id="txtUrlREValidator" runat="server" ErrorMessage="*" ControlToValidate="txtUrl" ValidationExpression="^[\w-_./:\?&=]+" Display="Dynamic"></asp:regularexpressionvalidator>
						</td>
					</tr>
					<tr>
						<td colspan="2" class="ibn-value">
							<b><%= LocRM.GetString("Description")%>:</b><br />
							<asp:TextBox Runat="server" ID="txtDescription" Width="350" CssClass="text" TextMode="MultiLine" Rows="4"></asp:TextBox>
						</td>
					</tr>
				</table>
		</td>
		<td style="padding:5px" width="50%" valign=top>
			<ibn:BlockHeaderLight id="hdrOrganization" runat="server" />
				<table class="ibn-stylebox-light text" cellSpacing="0" cellPadding="4" border="0" width="100%" style="table-layout:fixed">
					<tr>
						<td width="120px"><b><%= LocRM.GetString("Organization")%>:</b></td>
						<td>
							<asp:DropDownList Runat="server" ID="ddlOrganization" Width="230"></asp:DropDownList>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("OrganizationName")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtOrganizationName" Width="230" CssClass="text"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("OrganizationUnit")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtOrganizationUnit" Width="230" CssClass="text"></asp:TextBox>
						</td>
					</tr>
				</table>
			<ibn:BlockHeaderLight id="hdrEmails" runat="server" />
				<table class="ibn-stylebox-light text" cellSpacing="0" cellPadding="4" border="0" width="100%" style="table-layout:fixed">
					<tr>
						<td width="120px"><b><%= LocRM.GetString("VCardEMailType_Home")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtEmailHome" Width="230" CssClass="text" MaxLength="255"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardEMailType_Work")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtEmailWork" Width="230" CssClass="text" MaxLength="255"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardEMailType_None")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtEmailNone" Width="230" CssClass="text" MaxLength="255"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("EmailPreferred")%>:</b></td>
						<td>
							<asp:DropDownList Runat="server" ID="ddlEmailPreferred" Width="230"></asp:DropDownList>
						</td>
					</tr>
				</table>
			
			<ibn:BlockHeaderLight id="hdrPhones" runat="server" />
				<table class="ibn-stylebox-light text" cellSpacing="0" cellPadding="4" border="0" width="100%" style="table-layout:fixed">
					<tr>
						<td width="120px"><b><%= LocRM.GetString("VCardTelephoneType_Pref")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtPhonePref" Width="230" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardTelephoneType_Home")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtPhoneHome" Width="230" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardTelephoneType_Work")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtPhoneWork" Width="230" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardTelephoneType_Cell")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtPhoneCell" Width="230" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td><b><%= LocRM.GetString("VCardTelephoneType_Fax")%>:</b></td>
						<td>
							<asp:TextBox Runat="server" ID="txtPhoneFax" Width="230" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
					</tr>
				</table>
		</td>
	</tr>
	<tr>
		<td colspan="2" style="padding: 0 5 5 5" >
			<ibn:BlockHeaderLight id="hdrAddresses" runat="server" />
				<table class="ibn-stylebox-light text" cellSpacing="0" cellPadding="3" border="0" width="100%" style="table-layout:fixed">
					<tr>
						<td width="190px" style="padding-left:5">
							<b><%= LocRM.GetString("AddressType")%>:</b><br>
							<asp:DropDownList Runat="server" ID="ddlAddressType" Width="180"></asp:DropDownList>
						</td>
						<td width="190px" style="padding-left:5">
							<b><%= LocRM.GetString("AddressPostalCode")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressPostalCode" Width="175" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
						<td width="190px" style="padding-left:5">
							<b><%= LocRM.GetString("AddressCountry")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressCountry" Width="175" CssClass="text" MaxLength="50"></asp:TextBox>
						</td>
						<td style="padding-left:5">
							<b><%= LocRM.GetString("AddressRegion")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressRegion" Width="175" CssClass="text" MaxLength="255"></asp:TextBox>
						</td>
					</tr>
					<tr>
						<td>&nbsp;</td>
						<td style="padding-left:5">
							<b><%= LocRM.GetString("AddressLocality")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressLocality" Width="175" CssClass="text"></asp:TextBox>
						</td>
						<td style="padding-left:5">
							<b><%= LocRM.GetString("AddressStreet")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressStreet" Width="175" CssClass="text"></asp:TextBox>
						</td>
						<td style="padding-left:5">
							<b><%= LocRM.GetString("AddressExtra")%>:</b><br>
							<asp:TextBox Runat="server" ID="txtAddressExtra" Width="175" CssClass="text"></asp:TextBox>
						</td>
					</tr>
				</table>
		</td>
	</tr>
	<tr>
		<td vAlign="bottom" height="35" colspan="2" align="right" style="padding-right:15px;">
			<btn:imbutton class="text" id="btnSave" Runat="server" style="width:105px;" CustomImage="../layouts/images/saveitem.gif"></btn:imbutton>&nbsp;&nbsp;
			<btn:imbutton class="text" CausesValidation="false" id="btnCancel" Runat="server" style="width:105px;" IsDecline="true"></btn:imbutton>
		</td>
	</tr>
</table>
