<%@ Page Language="C#" AutoEventWireup="true" Inherits="Mediachase.UI.Web.Incidents.AddPortalAttach" Codebehind="AddPortalAttach.aspx.cs" %>
<%@ register TagPrefix="dg" namespace="Mediachase.UI.Web.Modules.DGExtension" Assembly="Mediachase.UI.Web" %>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title><%= LocRM.GetString("tAddIBNFiles")%></title>
		<link href='../layouts/styles/windows.css' type="text/css" rel="stylesheet" />
		<link href='../Themes/XP/theme.css' rel="stylesheet" />
		<link href='../Themes/XP/color1.css' rel="stylesheet" />
</head>
<body onload='javascript:window.setTimeout("ResizeAttachForm()", 100);'>
    <form id="form1" runat="server">
    <table cellspacing="0" cellpadding="0" border="0" width="100%">
	    <tr id="pathTr">
		    <td class="ibn-navline text" style="padding: 5px 5px 5px 10px;">
			    <asp:label id="lblPathTitle" CssClass="text" runat="server"></asp:label>:&nbsp;&nbsp;
			    <asp:label id="lblPath" runat="server" cssclass="ibn-nav"></asp:label>
		    </td>
	    </tr>
	    <tr>
		    <td>
		      <div id="tableDiv" style="height:450px;width:640px;overflow-y:auto;overflow-x:auto;overflow:auto;">
			    <dg:datagridextended id="grdMain" runat="server" allowsorting="True" allowpaging="True" width="100%"
					    autogeneratecolumns="False" borderwidth="0" gridlines="None" cellpadding="1"	
					    PageSize="10" LayoutFixed="True" enableviewstate="false">
				    <columns>
					    <asp:boundcolumn visible="false" datafield="Id"></asp:boundcolumn>
					    <asp:boundcolumn visible="false" datafield="Weight"></asp:boundcolumn>
					    <asp:templatecolumn headerstyle-cssclass="ibn-vh2" itemstyle-cssclass="ibn-vb2" headerstyle-width="25"
						    itemstyle-width="25">
						    <HeaderTemplate>
							    <asp:checkbox runat="server" id="chkAll" onclick="CheckAll(this);"></asp:checkbox>
						    </HeaderTemplate>
						    <itemtemplate>
							    <input value='<%#DataBinder.Eval(Container.DataItem, "Id").ToString()%>' type="checkbox" runat="server" id="chkItem" Visible='<%# (int)DataBinder.Eval(Container.DataItem, "Weight")>1%>' />
						    </itemtemplate>
					    </asp:templatecolumn>
					    <asp:templatecolumn headerstyle-cssclass="ibn-vh2" itemstyle-cssclass="ibn-vb2" headerstyle-width="21"
						    itemstyle-width="21">
						    <itemtemplate>
							    <img src='<%# DataBinder.Eval(Container.DataItem, "Icon")%>' width="16" height="16">
						    </itemtemplate>
					    </asp:templatecolumn>
					    <asp:boundcolumn headerstyle-cssclass="ibn-vh2" itemstyle-cssclass="ibn-vb2" datafield="Name"
						    sortexpression="sortName"></asp:boundcolumn>
						  <asp:TemplateColumn>
						    <ItemStyle CssClass="ibn-vb2" Width="25px"/>
						    <HeaderStyle CssClass="ibn-vh2" Width="25px" />
						    <HeaderTemplate>
						      <img src='../Layouts/Images/selectall.gif' title='<%# LocRM.GetString("tAddSelected") %>' style="cursor:pointer;" width="16" height="16" onclick='SelectChecked();' />
						    </HeaderTemplate>
						    <ItemTemplate>
							    <asp:ImageButton CommandName="Select" title='<%# LocRM.GetString("tAddFile") %>' id="ibRelate" runat="server" imageurl="../Layouts/Images/Select.gif" Width="16" Height="16" Visible='<%# (int)DataBinder.Eval(Container.DataItem, "Weight")>1%>'></asp:ImageButton>
						    </ItemTemplate>
					    </asp:TemplateColumn>
				    </columns>
			    </dg:datagridextended>
			    </div>
			  </td>
	    </tr>
    </table>
    <asp:LinkButton ID="lbSelectChecked" Runat="server" Visible="False"></asp:LinkButton>
    <input type="hidden" id="hidForSelect" runat="server" />
    <script type="text/javascript"> 
		  window.onresize = ResizeAttachForm;
		  
		  function SelectChecked()
	    {
		    var Ids = GetSelectedCbString();
		    if(Ids!="")
		    {
			    document.forms[0].<%= hidForSelect.ClientID%>.value = Ids;
			    <%= Page.GetPostBackClientEvent(lbSelectChecked, "")%>
		    }
	    }
	    
	    function CloseAll(str)
	    {
	      window.opener.top.updateAttachments2(str);
	      window.close();
	    }
		</script>
    </form>
</body>
</html>
