﻿<%@ Page Language="C#" CodeBehind="ForumNodeView.aspx.cs" Inherits="Mediachase.UI.Web.Modules.ForumNodeView" %>
<%@ Reference Control="~/Modules/ForumControls/ForumNodeFiles.ascx" %>
<%@ register TagPrefix="mc" namespace="Mediachase.UI.Web.Modules" Assembly="Mediachase.UI.Web" %>
<%@ Register TagPrefix="ibn" TagName="ForumNodeFiles" src="ForumControls\ForumNodeFiles.ascx" %>
<%@ Register TagPrefix="ibn" Assembly="Mediachase.UI.Web" Namespace="Mediachase.UI.Web.Modules.ForumControls" %>

<html>
  <head>
    <title runat="server" id="tagTitle"></title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<link href="../layouts/styles/windows.css" type=text/css rel=stylesheet >
	<link href="../Themes/XP/theme.css" rel="stylesheet">
	<link href="../Themes/XP/color1.css" rel="stylesheet">
	<link href="../layouts/styles/Forum.css" rel="stylesheet">
	<style>
		p {padding:0; margin:0; }
	</style>
	<script language="javascript">
		window.onresize = ResizeForm
		
		function ResizeForm()
		{
			var obj = document.getElementById('mainDiv');
			var objTBL = document.getElementById('<%=trInfo.ClientID%>');
			if(obj)
			{
				var iheight = document.body.clientHeight;
				var iwidth = document.body.clientWidth;
				obj.style.height = iheight - objTBL.offsetHeight;
				obj.style.width = iwidth;
			}
		}
	</script>
  </head>
  <body onload='javascript:window.setTimeout("ResizeForm()", 100);' leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" style="margin:0px;background-color:#ffffff">
	
	<mc:FixedForm id="frmMain" method="post" runat="server" bgcolor="#ece9d8" enctype="multipart/form-data">
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr bgcolor="#ECE9D8" id="trInfo" runat="server">
			<td class="ibn-navline">
				<table cellpadding="5" class="ibn-propertysheet">
					<tr>
						<td class="ibn-label"><%= LocRM2.GetString("Sender")%>:</td>
						<td width="90%"><ibn:IbnUser runat="server" ID="ucCreator" /></td>
					</tr>
					<tr bgcolor="#ECE9D8">
						<td class="ibn-label"><%= LocRM2.GetString("Subject")%>:</td>
						<td><asp:Label ID="lblSubj" Runat="server"></asp:Label></td>
					</tr>
					<tr bgcolor="#ECE9D8">
						<td valign="top" class="ibn-label"><%= LocRM2.GetString("Attachments")%>:</td>
						<td valign="top"><ibn:ForumNodeFiles Delimeter=" &nbsp; " ID="ucAttachments" runat="server" /></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td class="ibn-navline">
				<div id="mainDiv" style="height:440px;width:713px;overflow-y:auto;overflow-x:auto; padding:10px;">
					<asp:Label ID="lblBody" Runat="server" CssClass="text"></asp:Label>
				</div>
			</td>
		</tr>
	</table>
	</mc:FixedForm>
  </body>
</html>
