function BuildIndexArray(aFiles, aFileTitles, aStopWords)
{
    // filenames & titles
    aFiles[1] = "_index_entry_not_found.html"
    aFileTitles[1] = "Empty Index Entry"
    aFiles[2] = "_topic_not_found.html"
    aFileTitles[2] = "Topic Not Found"
    aFiles[3] = "CreateIssue.html"
    aFileTitles[3] = "Создание инцидента"
    aFiles[4] = "FileLibrary.html"
    aFileTitles[4] = "Работа с библиотекой файлов"
    aFiles[5] = "CreateReport.html"
    aFileTitles[5] = "Создание отчета"
    aFiles[6] = "CreateNewTask.html"
    aFileTitles[6] = "Создание новой задачи"
    aFiles[7] = "CreateNewProject.html"
    aFileTitles[7] = "Создание нового проекта"
    aFiles[8] = "CreateNewToDo.html"
    aFileTitles[8] = "Создание нового поручения"
    aFiles[9] = "CreateNewDocument.html"
    aFileTitles[9] = "Создание нового документа"
    aFiles[10] = "CreateNewCalendarEntry.html"
    aFileTitles[10] = "Создание нового мероприятия"
    aFiles[11] = "CreateNewTimesheet.html"
    aFileTitles[11] = "Создание листов учета рабочего времени"
    aFiles[12] = "ViewActualInformation.html"
    aFileTitles[12] = "Просмотр актуальной информации"
    aFiles[13] = "AddNewUser.html"
    aFileTitles[13] = "Приглашение нового пользователя"
    aFiles[14] = "SystemNotifications.html"
    aFileTitles[14] = "Настройка системы уведомления"
    aFiles[15] = "EditPersonalSettings.html"
    aFileTitles[15] = "Изменение личных настроек"
    aFiles[16] = "EditPersonalInformation.html"
    aFileTitles[16] = "Изменение личной информации"
    aFiles[17] = "CompanyInformation.html"
    aFileTitles[17] = "Информация о компании"

    // stopwords
    aStopWords["_empty"] = "1"
    aStopWords["_index"] = "1,2"
    aStopWords["_entry"] = "1"
    aStopWords["_selected"] = "1"
    aStopWords["_target"] = "1,2"
    aStopWords["_topics"] = "1"
    aStopWords["_associated"] = "1"
    aStopWords["_with"] = "1,2"
    aStopWords["_chosen"] = "1"
    aStopWords["_parent"] = "1"
    aStopWords["_please"] = "1"
    aStopWords["_select"] = "1,2"
    aStopWords["_child"] = "1"
    aStopWords["_topic"] = "2"
    aStopWords["_found"] = "2"
    aStopWords["_link"] = "2"
    aStopWords["_just"] = "2"
    aStopWords["_clicked"] = "2"
    aStopWords["_was"] = "2"
    aStopWords["_able"] = "2"
    aStopWords["_connect"] = "2"
    aStopWords["_page"] = "2"
    aStopWords["_possible"] = "2"
    aStopWords["_reasons"] = "2"
    aStopWords["_remedies"] = "2"
    aStopWords["_follows"] = "2"
    aStopWords["_reasonremedy"] = "2"
    aStopWords["_destination"] = "2"
    aStopWords["_part"] = "2"
    aStopWords["_area"] = "2"
    aStopWords["_specified"] = "2"
    aStopWords["_filtered"] = "2"
    aStopWords["_field.either"] = "2"
    aStopWords["_another"] = "2"
    aStopWords["_filter"] = "2"
    aStopWords["_url"] = "2"
    aStopWords["_incorrect"] = "2"
    aStopWords["_changed.use"] = "2"
    aStopWords["_search"] = "2"
    aStopWords["_function"] = "2"
    aStopWords["_instead"] = "2"
    aStopWords["_problems"] = "2"
    aStopWords["_help"] = "2"
    aStopWords["_installation.rerun"] = "2"
    aStopWords["_setup"] = "2"
    aStopWords["_product"] = "2"
    aStopWords["_related"] = "2"
    aStopWords["_repair"] = "2"
    aStopWords["_option"] = "2"
    aStopWords["_additional"] = "2"
    aStopWords["_available"] = "2"
    aStopWords["_filters"] = "2"
    aStopWords["_click"] = "2"
    aStopWords["_back"] = "2"
    aStopWords["_return"] = "2"
    aStopWords["_parameters"] = "2"
    aStopWords["_keyword"] = "2"
    aStopWords["_moniker"] = "2"
    aStopWords["_создание"] = "3,5,6,7,8,9,10,11,13"
    aStopWords["_инцидента"] = "3"
    aStopWords["_чтобы"] = "3,4,5,6,7,8,9,10,11,12,13,16,17"
    aStopWords["_создать"] = "3,4,5,6,7,8,11,13"
    aStopWords["_новый"] = "3,5,7,11"
    aStopWords["_инцидент"] = "3"
    aStopWords["_воспользуйтесь"] = "3,4,5,6,7,9,10,11,15,17"
    aStopWords["_кнопкой"] = "3,4,5,6,7,9,10,11,15,17"
    aStopWords["_«новый"] = "3,4,5,7,8,9,11,13"
    aStopWords["_инцидент»"] = "3"
    aStopWords["_правом"] = "3,5,7,15,16"
    aStopWords["_верхнем"] = "3,5,7,15,16"
    aStopWords["_углу"] = "3,5,7,15,16"
    aStopWords["_страницы"] = "3,7,12,15,16"
    aStopWords["_«инциденты»"] = "3"
    aStopWords["_на"] = "3,4,5,6,7,8,9,10,11,12,13,15,16"
    aStopWords["_странице"] = "3,5,6,7,8,10,11,12,13,15,17"
    aStopWords["_заполните"] = "3,6,7,9,10,11,13,17"
    aStopWords["_три"] = "3,6"
    aStopWords["_блока"] = "3,7,13"
    aStopWords["_данных"] = "3,5"
    aStopWords["_«основная"] = "3,9,10"
    aStopWords["_информация»"] = "3,9,10,12"
    aStopWords["_«информация"] = "3,9,10,16,17"
    aStopWords["_категориях»"] = "3,9,10"
    aStopWords["_«присоединение"] = "3"
    aStopWords["_файла»"] = "3"
    aStopWords["_блок"] = "3,9"
    aStopWords["_позволяет"] = "3"
    aStopWords["_сразу"] = "3,11,13"
    aStopWords["_прикрепить"] = "3,8"
    aStopWords["_инциденту"] = "3"
    aStopWords["_документ"] = "3,4,5,6,7,8,9,10,11,12,13,15,16,17"
    aStopWords["_для"] = "3,4,5,6,7,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_этого"] = "3,9,12"
    aStopWords["_«обзор»"] = "3,4,9,17"
    aStopWords["_«browse"] = "3"
    aStopWords["_выберете"] = "3"
    aStopWords["_нужный"] = "3,4,17"
    aStopWords["_файл"] = "3,4,8,9,17"
    aStopWords["_после"] = "3,4,7"
    aStopWords["_внесения"] = "3,7,17"
    aStopWords["_всех"] = "3,12"
    aStopWords["_нажмите"] = "3,4,5,6,7,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_«сохранить»"] = "3,4,6,7,8,9,10,11,13,14,15,16,17"
    aStopWords["_подробнее"] = "3,7"
    aStopWords["_просмотре"] = "3,15,16"
    aStopWords["_создании"] = "3,6,7,8,9,10,11,13,14"
    aStopWords["_смотрите"] = "3,4,5,6,7,8,9,10,11,12,13,15,16,17"
    aStopWords["_разделе"] = "3"
    aStopWords["_1.8.2"] = "3"
    aStopWords["_сообщение"] = "3,14"
    aStopWords["_новом"] = "3"
    aStopWords["_инциденте"] = "3"
    aStopWords["_«ibn"] = "3,7,15,16"
    aStopWords["_4.5"] = "3,4,5,6,7,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_руководство"] = "3,4,5,6,7,8,11,12,13,14,15,16"
    aStopWords["_пользователя"] = "3,4,5,6,7,8,9,10,11,12,13,15,16"
    aStopWords["_менеджеров"] = "3,4,5,6,7,8,11,12,13"
    aStopWords["_работа"] = "4,11"
    aStopWords["_библиотекой"] = "4"
    aStopWords["_файлов"] = "4"
    aStopWords["_раздел"] = "4,5,10,11,12,14,15,16,17"
    aStopWords["_«библиотека»"] = "4,8"
    aStopWords["_левого"] = "4"
    aStopWords["_меню"] = "4,6,8,11,13,14"
    aStopWords["_содержит"] = "4,12"
    aStopWords["_информацию"] = "4,8,12,16"
    aStopWords["_содержащихся"] = "4"
    aStopWords["_библиотеке"] = "4"
    aStopWords["_файлах"] = "4"
    aStopWords["_откройте"] = "4,16"
    aStopWords["_вкладку"] = "4,8,16"
    aStopWords["_«все"] = "4"
    aStopWords["_файлы»"] = "4"
    aStopWords["_левое"] = "4,13"
    aStopWords["_выберите"] = "4,5,6,7,8,10,11,12,13,14,17"
    aStopWords["_объект"] = "4,12"
    aStopWords["_которому"] = "4"
    aStopWords["_принадлежит"] = "4"
    aStopWords["_интересующая"] = "4"
    aStopWords["_вас"] = "4,11,12"
    aStopWords["_папка"] = "4"
    aStopWords["_откроется"] = "4,9,11,12"
    aStopWords["_страница"] = "4,9,11,12"
    aStopWords["_«файлы»"] = "4"
    aStopWords["_просмотреть"] = "4,12"
    aStopWords["_файле"] = "4"
    aStopWords["_папке"] = "4"
    aStopWords["_«просмотреть"] = "4,5"
    aStopWords["_детали»"] = "4"
    aStopWords["_опубликовать"] = "4"
    aStopWords["_пункт"] = "4,14,17"
    aStopWords["_«библиотека"] = "4"
    aStopWords["_общие"] = "4"
    aStopWords["_файлы"] = "4"
    aStopWords["_папки»"] = "4"
    aStopWords["_перейдите"] = "4,13"
    aStopWords["_папку"] = "4"
    aStopWords["_которой"] = "4"
    aStopWords["_вы"] = "4,6,12,13"
    aStopWords["_хотите"] = "4,12,13"
    aStopWords["_сохранить"] = "4"
    aStopWords["_кнопку"] = "4,5,8"
    aStopWords["_файл»"] = "4,8"
    aStopWords["_выбрать"] = "4"
    aStopWords["_«загрузить»"] = "4"
    aStopWords["_того"] = "4"
    aStopWords["_как"] = "4"
    aStopWords["_будет"] = "4,13"
    aStopWords["_загружен"] = "4"
    aStopWords["_сможете"] = "4"
    aStopWords["_увидеть"] = "4"
    aStopWords["_его"] = "4,5,12"
    aStopWords["_списке"] = "4"
    aStopWords["_папки"] = "4"
    aStopWords["_щелкните"] = "4,12"
    aStopWords["_по"] = "4,12"
    aStopWords["_названию"] = "4,12"
    aStopWords["_файла"] = "4"
    aStopWords["_загрузить"] = "4"
    aStopWords["_свой"] = "4"
    aStopWords["_компьютер"] = "4"
    aStopWords["_новую"] = "4,6"
    aStopWords["_ту"] = "4"
    aStopWords["_библиотеки"] = "4"
    aStopWords["_«новая"] = "4,6,11"
    aStopWords["_окне"] = "4,6,7,8,10,12"
    aStopWords["_папка»"] = "4"
    aStopWords["_введите"] = "4,8,11"
    aStopWords["_название"] = "4,5"
    aStopWords["_создаваемой"] = "4"
    aStopWords["_удалить"] = "4"
    aStopWords["_«удалить»"] = "4"
    aStopWords["_переместить"] = "4"
    aStopWords["_один"] = "4"
    aStopWords["_или"] = "4,11,16"
    aStopWords["_несколько"] = "4,13"
    aStopWords["_папок"] = "4"
    aStopWords["_какую-либо"] = "4"
    aStopWords["_другую"] = "4"
    aStopWords["_отметьте"] = "4,5,6,11,13,14"
    aStopWords["_эти"] = "4"
    aStopWords["_пунктом"] = "4,6"
    aStopWords["_«переместить"] = "4"
    aStopWords["_выделенные»"] = "4"
    aStopWords["_«действия»"] = "4,11,13"
    aStopWords["_открывшемся"] = "4"
    aStopWords["_из"] = "4,11"
    aStopWords["_списка"] = "4,11"
    aStopWords["_которую"] = "4,13"
    aStopWords["_вашу"] = "4"
    aStopWords["_«переместить»"] = "4"
    aStopWords["_переместятся"] = "4"
    aStopWords["_выбранную"] = "4"
    aStopWords["_получения"] = "4,5,6,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_более"] = "4,5,6,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_подробной"] = "4,5,6,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_информации"] = "4,5,6,7,8,9,10,11,12,13,14,15,16,17"
    aStopWords["_работе"] = "4"
    aStopWords["_1.12"] = "4"
    aStopWords["_библиотека"] = "4"
    aStopWords["_ibn"] = "4,5,6,8,9,10,11,12,13,14,17"
    aStopWords["_отчета"] = "5"
    aStopWords["_пользовательский"] = "5"
    aStopWords["_отчет"] = "5,12"
    aStopWords["_«главное"] = "5"
    aStopWords["_отчеты»"] = "5"
    aStopWords["_отчет»"] = "5"
    aStopWords["_окна"] = "5,16"
    aStopWords["_«общие"] = "5"
    aStopWords["_запустится"] = "5"
    aStopWords["_мастер"] = "5"
    aStopWords["_создания"] = "5,6,7,9,10"
    aStopWords["_нового"] = "5,7,8,9,10,11,13"
    aStopWords["_элемент"] = "5"
    aStopWords["_поля"] = "5,17"
    aStopWords["_которые"] = "5,12,14"
    aStopWords["_будут"] = "5,12"
    aStopWords["_представлены"] = "5,12"
    aStopWords["_создаваемом"] = "5"
    aStopWords["_отчете"] = "5"
    aStopWords["_группировки"] = "5"
    aStopWords["_установите"] = "5"
    aStopWords["_фильтры"] = "5"
    aStopWords["_укажите"] = "5,13"
    aStopWords["_сортировки"] = "5"
    aStopWords["_вид"] = "5"
    aStopWords["_создаваемого"] = "5"
    aStopWords["_флажок"] = "5,6,11,13"
    aStopWords["_«отображать"] = "5"
    aStopWords["_пустые"] = "5"
    aStopWords["_группы»"] = "5"
    aStopWords["_отображать"] = "5"
    aStopWords["_группы"] = "5,6,13,14"
    aStopWords["_не"] = "5,11"
    aStopWords["_содержащие"] = "5"
    aStopWords["_объектов"] = "5,12"
    aStopWords["_проверить"] = "5"
    aStopWords["_отображаемых"] = "5"
    aStopWords["_при"] = "5"
    aStopWords["_выбранных"] = "5"
    aStopWords["_вами"] = "5"
    aStopWords["_настройках"] = "5"
    aStopWords["_проверьте"] = "5"
    aStopWords["_правильность"] = "5"
    aStopWords["_созданной"] = "5"
    aStopWords["_структуры"] = "5"
    aStopWords["_«создать»"] = "5,6"
    aStopWords["_1.13.3"] = "5"
    aStopWords["_шаблона"] = "5"
    aStopWords["_новой"] = "6"
    aStopWords["_задачи"] = "6,12"
    aStopWords["_задачу"] = "6,11"
    aStopWords["_задача»"] = "6"
    aStopWords["_«просмотр"] = "6,7,8,10,11"
    aStopWords["_проекта»"] = "6,7,11"
    aStopWords["_информационных"] = "6,7,13"
    aStopWords["_полей"] = "6,7,13"
    aStopWords["_общая"] = "6"
    aStopWords["_информация"] = "6,7,12,13,15,16,17"
    aStopWords["_состояния"] = "6,7"
    aStopWords["_тип"] = "6,11,14"
    aStopWords["_завершения"] = "6"
    aStopWords["_«должно"] = "6"
    aStopWords["_быть"] = "6"
    aStopWords["_подтверждено"] = "6"
    aStopWords["_менеджером»"] = "6"
    aStopWords["_если"] = "6,9,13"
    aStopWords["_необходимо"] = "6,8,9,13"
    aStopWords["_завершение"] = "6"
    aStopWords["_требовало"] = "6"
    aStopWords["_подтверждения"] = "6"
    aStopWords["_менеджера"] = "6"
    aStopWords["_«веха»"] = "6"
    aStopWords["_создаете"] = "6"
    aStopWords["_задачу-веху"] = "6"
    aStopWords["_категориях"] = "6"
    aStopWords["_«сохранить"] = "6,8,10"
    aStopWords["_назначить»"] = "6,8"
    aStopWords["_задачи»"] = "6"
    aStopWords["_вкладка"] = "6,7,10"
    aStopWords["_«главное»"] = "6"
    aStopWords["_блоке"] = "6,7,10"
    aStopWords["_«исполнители»"] = "6,8"
    aStopWords["_«изменить»"] = "6,7,10"
    aStopWords["_исполнителей"] = "6,7,8"
    aStopWords["_задач"] = "6"
    aStopWords["_поручений"] = "6"
    aStopWords["_разделы"] = "6,13"
    aStopWords["_1.6.5"] = "6"
    aStopWords["_1.7.2"] = "6"
    aStopWords["_постановка"] = "6"
    aStopWords["_проекта"] = "7"
    aStopWords["_проект"] = "7,11"
    aStopWords["_проект»"] = "7"
    aStopWords["_проектов»"] = "7"
    aStopWords["_четыре"] = "7,13"
    aStopWords["_основная"] = "7,13"
    aStopWords["_категории"] = "7,12"
    aStopWords["_отчетов"] = "7,12"
    aStopWords["_дополнительная"] = "7"
    aStopWords["_всей"] = "7"
    aStopWords["_«участники»"] = "7,10"
    aStopWords["_«команда»"] = "7"
    aStopWords["_аналогично"] = "7"
    aStopWords["_выбираются"] = "7"
    aStopWords["_исполнители"] = "7"
    aStopWords["_блоков"] = "7"
    aStopWords["_«спонсоры»"] = "7"
    aStopWords["_«заинтересованные"] = "7"
    aStopWords["_лица»"] = "7"
    aStopWords["_разделах"] = "7"
    aStopWords["_1.6.2"] = "7"
    aStopWords["_4.3"] = "7"
    aStopWords["_чего"] = "7,10,13"
    aStopWords["_начать"] = "7,10,13"
    aStopWords["_работу"] = "7,10,11,13"
    aStopWords["_поручения"] = "8,11,12"
    aStopWords["_новое"] = "8"
    aStopWords["_поручение"] = "8,11"
    aStopWords["_проделать"] = "8"
    aStopWords["_следующие"] = "8,16"
    aStopWords["_действия"] = "8,16"
    aStopWords["_«новое"] = "8"
    aStopWords["_поручение»"] = "8"
    aStopWords["_верхней"] = "8,9,10"
    aStopWords["_строки"] = "8,11"
    aStopWords["_необходимую"] = "8"
    aStopWords["_поручения»"] = "8"
    aStopWords["_который"] = "8"
    aStopWords["_нужно"] = "8"
    aStopWords["_поручению"] = "8"
    aStopWords["_1.7.6.новое"] = "8"
    aStopWords["_документа"] = "9"
    aStopWords["_перейти"] = "9,10,11"
    aStopWords["_страницу"] = "9,10,12"
    aStopWords["_документ»"] = "9"
    aStopWords["_панели"] = "9,10"
    aStopWords["_инструментов"] = "9,10"
    aStopWords["_присоедините"] = "9"
    aStopWords["_создаваемому"] = "9"
    aStopWords["_документу"] = "9"
    aStopWords["_“browse"] = "9"
    aStopWords["_1.10.2"] = "9"
    aStopWords["_«руководство"] = "9,10"
    aStopWords["_менеджеров»"] = "9,10,15,16"
    aStopWords["_мероприятия"] = "10,12"
    aStopWords["_«создание"] = "10"
    aStopWords["_мероприятия»"] = "10"
    aStopWords["_блоки"] = "10"
    aStopWords["_состоянии"] = "10"
    aStopWords["_пригласить»"] = "10"
    aStopWords["_сформировать"] = "10"
    aStopWords["_состав"] = "10"
    aStopWords["_участников"] = "10"
    aStopWords["_«общее»"] = "10"
    aStopWords["_«участники"] = "10"
    aStopWords["_пользователей"] = "10,13,14"
    aStopWords["_1.9.2"] = "10"
    aStopWords["_планирование"] = "10"
    aStopWords["_4.2"] = "10"
    aStopWords["_листов"] = "11"
    aStopWords["_учета"] = "11"
    aStopWords["_рабочего"] = "11"
    aStopWords["_времени"] = "11"
    aStopWords["_лист"] = "11"
    aStopWords["_времени»"] = "11"
    aStopWords["_строка"] = "11"
    aStopWords["_интересующую"] = "11"
    aStopWords["_неделю"] = "11"
    aStopWords["_работы"] = "11"
    aStopWords["_над"] = "11"
    aStopWords["_задачей"] = "11"
    aStopWords["_задача"] = "11"
    aStopWords["_выполнение"] = "11"
    aStopWords["_участие"] = "11,12"
    aStopWords["_мероприятии"] = "11"
    aStopWords["_мероприятие/совещание/деловая"] = "11"
    aStopWords["_встреча"] = "11"
    aStopWords["_иная"] = "11"
    aStopWords["_установлен"] = "11"
    aStopWords["_типов"] = "11"
    aStopWords["_«задача»"] = "11"
    aStopWords["_«поручение»"] = "11"
    aStopWords["_«мероприятие»"] = "11"
    aStopWords["_соответствующую"] = "11"
    aStopWords["_мероприятие"] = "11,12"
    aStopWords["_поле"] = "11"
    aStopWords["_«описание»"] = "11"
    aStopWords["_количество"] = "11"
    aStopWords["_затраченных"] = "11"
    aStopWords["_часов"] = "11"
    aStopWords["_«остаться"] = "11,13"
    aStopWords["_созданию"] = "11"
    aStopWords["_еще"] = "11"
    aStopWords["_одной"] = "11"
    aStopWords["_1.6.9"] = "11"
    aStopWords["_листа"] = "11"
    aStopWords["_ля"] = "11"
    aStopWords["_просмотр"] = "12"
    aStopWords["_актуальной"] = "12"
    aStopWords["_«моя"] = "12"
    aStopWords["_работа»"] = "12"
    aStopWords["_отображается"] = "12"
    aStopWords["_вся"] = "12"
    aStopWords["_актуальная"] = "12"
    aStopWords["_текущий"] = "12"
    aStopWords["_момент"] = "12"
    aStopWords["_активные"] = "12"
    aStopWords["_открытые"] = "12"
    aStopWords["_проблемы"] = "12"
    aStopWords["_документы"] = "12"
    aStopWords["_проекты"] = "12"
    aStopWords["_которых"] = "12"
    aStopWords["_принимаете"] = "12"
    aStopWords["_об"] = "12"
    aStopWords["_интересующем"] = "12"
    aStopWords["_объекте"] = "12"
    aStopWords["_«календарь»"] = "12"
    aStopWords["_отражаются"] = "12"
    aStopWords["_все"] = "12"
    aStopWords["_запланированные"] = "12"
    aStopWords["_день"] = "12"
    aStopWords["_«помощь"] = "12"
    aStopWords["_ссылки"] = "12"
    aStopWords["_общий"] = "12"
    aStopWords["_порталу"] = "12"
    aStopWords["_созданные"] = "12"
    aStopWords["_шаблоны"] = "12"
    aStopWords["_редактирования"] = "12"
    aStopWords["_ваших"] = "12"
    aStopWords["_пользовательских"] = "12"
    aStopWords["_настроек"] = "12,15"
    aStopWords["_центра"] = "12"
    aStopWords["_поддержки"] = "12"
    aStopWords["_загрузки"] = "12"
    aStopWords["_дополнительных"] = "12"
    aStopWords["_приложений"] = "12"
    aStopWords["_актуальную"] = "12"
    aStopWords["_можно"] = "12"
    aStopWords["_также"] = "12"
    aStopWords["_любой"] = "12"
    aStopWords["_портала"] = "12,13,14,15,17"
    aStopWords["_используя"] = "12"
    aStopWords["_специальные"] = "12"
    aStopWords["_закладки"] = "12"
    aStopWords["_закладка"] = "12"
    aStopWords["_«активно»"] = "12"
    aStopWords["_список"] = "12"
    aStopWords["_активных"] = "12"
    aStopWords["_имеют"] = "12"
    aStopWords["_вам"] = "12,13"
    aStopWords["_отношение"] = "12"
    aStopWords["_строке"] = "12"
    aStopWords["_закладок"] = "12"
    aStopWords["_котором"] = "12"
    aStopWords["_просмотра"] = "12"
    aStopWords["_выбранного"] = "12"
    aStopWords["_объекта"] = "12,14"
    aStopWords["_можете"] = "12"
    aStopWords["_последние"] = "12"
    aStopWords["_обновления"] = "12"
    aStopWords["_закладку"] = "12"
    aStopWords["_«обновления»"] = "12"
    aStopWords["_доступны"] = "12"
    aStopWords["_«сегодня»"] = "12"
    aStopWords["_«вчера»"] = "12"
    aStopWords["_«2-6"] = "12"
    aStopWords["_дней"] = "12"
    aStopWords["_назад»"] = "12"
    aStopWords["_интересующее"] = "12"
    aStopWords["_обновление"] = "12"
    aStopWords["_которым"] = "12,13"
    aStopWords["_связано"] = "12"
    aStopWords["_выбранное"] = "12"
    aStopWords["_1.5.1"] = "12"
    aStopWords["_приглашение"] = "13"
    aStopWords["_пригласить"] = "13"
    aStopWords["_систему"] = "13,14"
    aStopWords["_пользовательскую"] = "13"
    aStopWords["_группу"] = "13"
    aStopWords["_«пользователи»"] = "13"
    aStopWords["_включить"] = "13"
    aStopWords["_открывшейся"] = "13,15"
    aStopWords["_пользователь»"] = "13"
    aStopWords["_личная"] = "13"
    aStopWords["_персональные"] = "13"
    aStopWords["_настройки"] = "13,14,17"
    aStopWords["_группах"] = "13"
    aStopWords["_принадлежать"] = "13"
    aStopWords["_пользователь"] = "13"
    aStopWords["_учетных"] = "13"
    aStopWords["_записей"] = "13"
    aStopWords["_подряд"] = "13"
    aStopWords["_приглашении"] = "13"
    aStopWords["_новых"] = "13"
    aStopWords["_1.3.3"] = "13"
    aStopWords["_1.15.3"] = "13"
    aStopWords["_2.4"] = "13"
    aStopWords["_администратора"] = "13,14"
    aStopWords["_администрирование"] = "13,14,17"
    aStopWords["_настройка"] = "14"
    aStopWords["_системы"] = "14"
    aStopWords["_уведомления"] = "14"
    aStopWords["_«администратор"] = "14,17"
    aStopWords["_дополнительные"] = "14"
    aStopWords["_сервисы"] = "14"
    aStopWords["_уведомления»"] = "14"
    aStopWords["_сообщения"] = "14"
    aStopWords["_должны"] = "14"
    aStopWords["_получать"] = "14"
    aStopWords["_это"] = "14"
    aStopWords["_настроив"] = "14"
    aStopWords["_редактировании"] = "14,15,16"
    aStopWords["_компании"] = "14,17"
    aStopWords["_см"] = "14"
    aStopWords["_5.1.3"] = "14"
    aStopWords["_изменение"] = "15,16"
    aStopWords["_личных"] = "15"
    aStopWords["_изменения"] = "15,16"
    aStopWords["_«редактировать"] = "15"
    aStopWords["_настройки»"] = "15"
    aStopWords["_внесите"] = "15,16"
    aStopWords["_необходимые"] = "15,16"
    aStopWords["_1.4"] = "15,16"
    aStopWords["_пользователе"] = "15,16"
    aStopWords["_личной"] = "16"
    aStopWords["_отредактировать"] = "16"
    aStopWords["_внесенную"] = "16"
    aStopWords["_регистрационную"] = "16"
    aStopWords["_форму"] = "16"
    aStopWords["_сменить"] = "16"
    aStopWords["_пароль"] = "16"
    aStopWords["_проделайте"] = "16"
    aStopWords["_ссылку"] = "16"
    aStopWords["_«детали»"] = "16"
    aStopWords["_«редактировать»"] = "16"
    aStopWords["_пользователе»"] = "16"
    aStopWords["_компании»"] = "17"
    aStopWords["_представленные"] = "17"
    aStopWords["_необходимой"] = "17"
    aStopWords["_информацией"] = "17"
    aStopWords["_изменить"] = "17"
    aStopWords["_логотип"] = "17"
    aStopWords["_графический"] = "17"
    aStopWords["_оптимальный"] = "17"
    aStopWords["_размер"] = "17"
    aStopWords["_логотипа"] = "17"
    aStopWords["_100х50"] = "17"
    aStopWords["_пикселей"] = "17"
    aStopWords["_1.1"] = "17"
}
