<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Public.Modules.SignUp" Codebehind="SignUp.ascx.cs" %>
<%@ register TagPrefix="btn" namespace="Mediachase.UI.Web.Modules" Assembly="Mediachase.UI.Web" %>
<%@ Register TagPrefix="cc1" Namespace="Mediachase.FileUploader.Web.UI" Assembly="Mediachase.FileUploader" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="..\..\Modules\BlockHeader.ascx" %>
<table class="ibn-stylebox2" cellspacing="0" cellpadding="0" width="100%" border="0">
	<tr>
		<td><ibn:blockheader id="tbSave" runat="server"></ibn:blockheader></td>
	</tr>
	<tr>
		<td>
			<table id="tblInputForm" runat="server" class="text" style="padding:0px 5px;" cellspacing="0" cellpadding="7" border="0">
				<colgroup>
					<col width="150px" />
					<col width="250px" />
					<col width="150px" />
					<col width="250px" />
					<col />
				</colgroup>
				<tr>
					<td colspan="5">
						<div class="text" style="PADDING-RIGHT:10px; PADDING-LEFT:10px; PADDING-BOTTOM:10px; PADDING-TOP:10px">
							<%=LocRM.GetString("Header") %>
						</div>
					</td>
				</tr>
				<tr>
					<td valign="top">
						<b><asp:label id="lblLoginTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label>:</b>
					</td>
					<td valign="top" colspan="3">
						<div style="float:left;">
							<asp:textbox id="txtLogin" runat="server" width="210" maxlength="50" CssClass="text"></asp:textbox>
						</div>
						<div style="float:left;width:8px;">&nbsp;</div>
						<div>
							<asp:regularexpressionvalidator id="txtRELoginValidator" runat="server" ErrorMessage="*" ControlToValidate="txtLogin" ValidationExpression="[\-0-9A-Za-z_.]+" Display="Dynamic"></asp:regularexpressionvalidator>
							<asp:Label id="lblError" runat="server" CssClass="ibn-error"></asp:Label>
						</div>
						<div style="clear:both;">
							<asp:Label id="lblWarning" runat="server" CssClass="ibn-error"></asp:Label>
						</div>
					</td>
					<td></td>
				</tr>
				<tr>
					<td style="width:150px;"><asp:label id="lblPasswordTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td noWrap style="width:250px;"><asp:textbox id="txtPassword" runat="server" width="210" maxlength="50" textmode="Password" CssClass="text"></asp:textbox></td>
					<td noWrap style="width:150px;"><nobr><asp:label id="lblConfirmTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></nobr></td>
					<td noWrap style="width:250px;"><asp:textbox id="txtConfirm" runat="server" width="210" maxlength="50" textmode="Password" CssClass="text"></asp:textbox><asp:comparevalidator id="Comparevalidator1" runat="server" controltovalidate="txtPassword" errormessage="*" controltocompare="txtConfirm"></asp:comparevalidator></td>
					<td>&nbsp;</td>
				</tr>
				<tr>
					<td><asp:label id="lblFirstNameTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td noWrap><asp:textbox id="txtFirstName" runat="server" width="210" maxlength="50" CssClass="text"></asp:textbox><asp:requiredfieldvalidator id="txtFirstNameRFValidator" runat="server" controltovalidate="txtFirstName" errormessage="*"></asp:requiredfieldvalidator></td>
					<td><asp:label id="lblLastNameTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td noWrap><asp:textbox id="txtLastName" runat="server" width="210" maxlength="50" CssClass="text"></asp:textbox><asp:requiredfieldvalidator id="txtLastNameRFValidator" runat="server" controltovalidate="txtLastName" errormessage="*"></asp:requiredfieldvalidator></td>
				</tr>
				<tr>
					<td><asp:label id="lblEmailTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td noWrap colspan="3"><asp:textbox id="txtEmail" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox><asp:requiredfieldvalidator id="txtEmailRFValidator" runat="server" controltovalidate="txtEmail" errormessage="*"></asp:requiredfieldvalidator>
						<asp:RegularExpressionValidator id="RegularExpressionValidator1" runat="server" ControlToValidate="txtEmail" ErrorMessage="Wrong Email" ValidationExpression="\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*" Display="Dynamic"></asp:RegularExpressionValidator>
					</td>
					
				</tr>
				<tr>
					<td vAlign="top"><asp:label id="lblPhotoTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td>
						<cc1:McHtmlInputFile id="fPhoto" runat="server" CssClass="text"></cc1:McHtmlInputFile>
						<asp:RegularExpressionValidator id="RegularExpressionValidator2" runat="server" ControlToValidate="fPhoto" ErrorMessage="Wrong Format" ValidationExpression="^[\w-\./:&amp;-- \\]+((\.[jJ][pP][gG])|(\.[jJ][pP][eE][gG])|(\.[gG][iI][fF])|(\.[pP][nN][gG])|(\.[tT][iI][fF][fF])|(\.[bB][mM][pP]))$" Display="Dynamic"></asp:RegularExpressionValidator></td>
					<td rowSpan="6" colspan="2"></td>
				</tr>
				<tr>
					<td><asp:label id="lblPhoneTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td><asp:textbox id="txtPhone" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr>
					<td><asp:label id="lblFaxTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td><asp:textbox id="txtFax" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr>
					<td><asp:label id="lblMobileTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td><asp:textbox id="txtMobile" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr>
					<td><asp:label id="lblCompanyTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG>
					</td>
					<td><asp:textbox id="txtCompany" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr>
					<td><asp:label id="lblJobTitleTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG>
					</td>
					<td><asp:textbox id="txtJobTitle" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr>
					<td><asp:label id="lblDepartmentTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td><asp:textbox id="txtDepartment" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
					<td><asp:label id="lblLocationTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG></td>
					<td><asp:textbox id="txtLocation" runat="server" width="210" maxlength="255" CssClass="text"></asp:textbox></td>
				</tr>
				<tr id="trTimeZone" runat="server">
					<td><asp:label id="lblTimeZoneTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG><B></B></td>
					<td><asp:dropdownlist id="lstTimeZone" runat="server" width="210px" CssClass="text"></asp:dropdownlist></td>
					<td><asp:label id="lblLangTitle" CssClass="text" Runat="server" Font-Bold="True"></asp:label><STRONG>:</STRONG><B></B></td>
					<td><asp:dropdownlist id="lstLang" runat="server" width="210px" CssClass="text"></asp:dropdownlist></td>
				</tr>
				<tr>
					<td vAlign="center" align="right" colSpan="4" height="60"><btn:imbutton class="text" id="btnSave" Runat="server" style="width:105px;" CustomImage="../layouts/images/accept.gif" onserverclick="btnSave_ServerClick"></btn:imbutton>&nbsp;&nbsp;
						<btn:imbutton class="text" CausesValidation="false" id="btnCancel" Runat="server" style="width:105px;" IsDecline="true" onserverclick="btnCancel_ServerClick"></btn:imbutton></td>
				</tr>
			</table>
			<div style="padding:10px;">
				<asp:Label ID="lblReqWasSent" Runat=server ForeColor="#ff0000" CssClass="text"></asp:Label>
			</div>
		</td>
	</tr>
</table>
<asp:Button id="bSave" runat="server" Text="Button" style="VISIBILITY:hidden"></asp:Button>
