<%@ Page language="c#" Inherits="Mediachase.UI.Web.Home.PrivacyStatement" Codebehind="PrivacyStatement.aspx.cs" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD id=pT_headTag>
		<title>
			<%=LocRM.GetString("PrivacyStatement") %>
		</title>
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<script src="../Scripts/buttons.js"></script>
		<script src="../Scripts/browser.js"></script>
		<LINK href="../layouts/styles/windows.css" type="text/css" rel="stylesheet">
		<link href="../Themes/XP/theme.css" rel="stylesheet">
		<link href="../Themes/XP/color1.css" rel="stylesheet">
		<script><!--
		if ((browseris.mac) && !browseris.ie5up)
		{
			var macstyle = "../layouts/styles/mac.css";
			document.write("<link rel='stylesheet' Type='text/css' href='" + macstyle + "'>");
		}
	
		//--></script>
	</HEAD>
	<body class="UserBackground" id="pT_body" leftMargin="5" topMargin="5" marginwidth="5" marginheight="5">
		<form id="frmMain" runat="server">
		<body bgcolor="#FFFFFF">
		<div class=text>
<body bgcolor="#FFFFFF"><div class="ibn-propertysheet">
<p class="ibn-sectionheader">Mediachase Online Privacy Policy </p>
<p>This Privacy Statement describes our current privacy practices with regard to information we collect when you or your computer interact with our Web sites, including www.mediachase.com, store.mediachase.com, www.mediachase.net, and other sites within our domains. </p>
<p>Mediachase has a separate terms of use' statement that governs our practices with respect to your working information and transactions that are conducted in connection with your use of the Instant Business Network (IBN) Software service. The remainder of this privacy policy covers all other surrounding activities that happen with Mediachase. </p>
<p><strong>Information Collection and Use <br>
  </strong><br>
  We collect information from our users and their computers when they view our Web sites. We collect both personally identifiable and non-personally identifiable information. We also collect information from you when you request support or make inquiries about our products or services. </p>
<p>We may ask you to provide us with personally identifiable information at various points while you use our Web sites, such as when you register for a Web site account or when you purchase products or services from us. Examples of the types of personally identifiable information we collect range from your e-mail address to your name, street address, phone or fax number, e-mail address, and credit card information. </p>
<p>We use the personally identifiable information you provide about yourself to fulfill your requests for products and services, to contact you about your account, to complete and support your activities, to respond to your inquiries about our offerings, and to customize the content of our Web sites. We use your e-mail address and other personally identifiable information to send you service notifications about your account, about the services you currently use, if any, and concerning changes to our Privacy Statements, Acceptable Use Policy, Web site Terms of Use, or other legal or policy matters. If you have given us permission, we will use your e-mail address and other personally identifiable information to send you our newsletter or to communicate with you about products and services we believe may be of interest to you. </p>
<p>We also may use some of this information in anonymous or statistical forms, such as aggregating geographic information from user addresses or types of industries in which users work, to better understand our customers. We also may ask you to optionally provide us information about your interests to be used for similar purposes. We will ask your permission before using this type of information in a way that personally identifies you. </p>
<p><strong>Log Files <br>
  </strong><br>
  We use the information in our server log files to analyze trends in the usage of our Web sites, to administer and maintain our Web sites, to track a user's path through our Web sites, and to gather broad demographic statistics about our Web sites and the ways in which they are used. Most of the information in these files is not unique to you as an individual, such as the files requested and pages you visit on our Web sites, the Web sites from which you may have been referred to our Web sites, and information about the type of browser you use and its settings. Some of the log files contain IP addresses and other personally identifiable information, which are used to identify user connections and to resolve technical issues related to administration of our Web sites. </p>
<p><strong>Cookies <br>
  </strong><br>
  A cookie is a small text file stored on a computer that contains information associated with that computer. Our Web sites use cookies for several purposes, such as maintaining your login state, improving the content of our Web sites, providing you with information tailored to your interests, customizing the content of our Web pages, and improving the security of your use of our Web sites. Login cookies are linked to your e-mail address, which is stored with other personally identifiable information. </p>
<p>You can instruct your browser to stop accepting cookies from our Web sites. If you do so, however, you will hinder your experience by, for example, preventing yourself from enabling automatic memory when using the IBN software and viewing some information on our Web sites and logging into forums and message boards, as well as preventing us from displaying content or capabilities customized to the preferences you have specified. You should, however, be able to access most parts of our sites that are available to the general public. </p>
<p><strong>Disclosure of Information <br>
  </strong><br>
  We will not disclose personally identifiable information we collect from you to third parties without your permission except to the extent necessary </p>
<ul>
  <li>to fulfill your requests for products or services </li>
  <li>to protect the security of our software, services, Web sites, and users </li>
  <li>to protect ourselves from liability </li>
  <li>to respond to legal process or comply with law </li>
  <li>in connection with a merger, acquisition, or liquidation of the company </li>
</ul>
<p>We share statistical information about users of our web sites with third parties, including our vendors, customers, potential customers, distributors, and third parties that offer products or services for use with the IBN software. We do not link this information to any personally identifiable information. </p>
<p><strong>Public Forums <br>
  </strong><br>
  You may participate in public forums on our Web sites. Any information you make available in these forums would become public information and could be used by others to send you unsolicited communications. Please be careful about disclosing personal information in public forums. </p>
<p><strong>Security <br>
  </strong><br>
  We take measures to protect the security of personally identifiable information we hold about you. These measures include: </p>
<ul>
  <li>encrypting sensitive information during transmission, </li>
  <li>limiting the number of our employees who have access to personally identifiable information, </li>
  <li>requiring employees with access to personally identifiable information to take appropriate measures to safeguard it, and </li>
  <li>storing your information in secure places that are protected using standard security technologies. </li>
</ul>
<p><strong>Accessing Web Account Information <br>
  </strong><br>
  We will provide you with the means to ensure that personally identifiable information in your web account file is correct and current. You may review much of this information at any time by using your Mediachase Account on our Web site. If the information you wish to update or change is not available on our pages, please send an e-mail to <a href="mailto:support@mediachase.com">support@mediachase.com </a>,&nbsp;and we will endeavor to change the information for you. </p>
<p><strong>Changes to this Privacy Statement <br>
  </strong><br>
  Mediachase will occasionally update this Privacy Statement as our business and products evolve. When we do, we will also revise the &quot;last updated&quot; date at the top of the Privacy Statement. For material changes to this Privacy Statement, Mediachase will notify you by placing prominent notice on the Web site. </p>
<strong>Contact Us <br>
</strong><br>
If you have questions about this Privacy Statement, its implementation, or our practices, please contact us at <a href="mailto:support@mediachase.com">support@mediachase.com </a>.

</div>
		<table width=100% border=0 cellpadding=0 cellspacing=0>
		<tr>
			<td align=center><br>
				<input type="button" value='<%=LocRM.GetString("Close") %>' onclick="window.close();" class=text>
			</td>
		</tr>
		</table><br><br>
		</form>
	</body>
</HTML>
