<%@ Reference Page="~/Tasks/AddResources.aspx" %>
<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="..\Modules\BlockHeader.ascx" %>
<%@ Page language="c#" Inherits="Mediachase.UI.Web.Tasks.ResourcesEditorProject" Codebehind="AddResourcesProject.aspx.cs" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD id="pT_headTag">
		<title>
			<%=LocRM.GetString("tTitle") %>
		</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<script src="../Scripts/browser.js"></script>
		<script src="../Scripts/buttons.js"></script>		
		<LINK href="../layouts/styles/windows.css" type="text/css" rel="stylesheet">
		<link href="../Themes/XP/theme.css" rel="stylesheet">
		<link href="../Themes/XP/color1.css" rel="stylesheet">
		<script><!--
		if ((browseris.mac) && !browseris.ie5up)
		{
			var macstyle = "../layouts/styles/mac.css";
			document.write("<link rel='stylesheet' Type='text/css' href='" + macstyle + "'>");
		}
	
		//--></script>
		<script language="JavaScript"> 
			function disableEnterKey() 
			{ 
				try {
					if (window.event.keyCode == 13 && window.event.srcElement.type != "textarea")
						window.event.keyCode = 0;
				}
				catch (e) {}
			} 
		</script>
	</HEAD>
	<body class="UserBackground" id="pT_body" leftMargin="0" topMargin="0" marginwidth="0" marginheight="0">
		<form id="frmMain" runat="server">
			<ibn:blockheader id="secHeader" title="ToolBar" runat="server"></ibn:blockheader>
			<table class="text" style="HEIGHT: 100%" height="100%" cellSpacing="0" cellPadding="3" width="100%" border="0">
				<tr height="22">
					<td class="boldtext" width="320" height="22"><%=LocRM.GetString("Available") %>
						:</td>
					<td width="4">&nbsp;</td>
					<td class="ibn-navframe boldtext"><%=LocRM.GetString("Selected") %>
						:</td>
				</tr>
				<tr style="HEIGHT: 100%">
					<td vAlign="top" width="320">
						<!-- Groups & Users -->
						<table class="text" style="MARGIN-TOP: 5px" cellSpacing="0" cellPadding="3" width="100%">
							<tr>
								<td vAlign="top" height="96"><%=LocRM.GetString("User") %>
									:</td>
								<td vAlign="top"><asp:listbox id="lbUsers" runat="server" CssClass="text" Width="190px" SelectionMode="Multiple" Rows="10"></asp:listbox></td>
							</tr>
							<TR>
								<TD vAlign="top"></TD>
								<TD vAlign="top">
									<asp:CheckBox id="cbCanManage" runat="server"></asp:CheckBox>
								</TD>
							</TR>
							<TR>
								<TD vAlign="top"></TD>
								<TD vAlign="top">
									<asp:CheckBox id="cbConfirmed" runat="server"></asp:CheckBox>
								</TD>
							</TR>
							<tr>
								<td vAlign="top" height="28">&nbsp;</td>
								<td>
									<Button id="btnSave" runat="server" Text="Button" style="DISPLAY:none" onserverclick="btnSave_Click"></Button><button id="btnAdd" runat="server" Class="text" style="Width:160px" onserverclick="btnAdd_Click"></button></td>
							</tr>
						</table>
						<!-- End Groups & Users -->
					</td>
					<td width="4">&nbsp;</td>
					<td vAlign="top" class="ibn-navframe" height="100%">
						<!-- Data GRID -->
						<div style="OVERFLOW-Y:auto;HEIGHT:300px">
							<asp:DataGrid Runat="server" ID="dgMembers" AutoGenerateColumns="False" AllowPaging="False" AllowSorting="False" cellpadding="1" gridlines="None" CellSpacing="1" borderwidth="0px">
								<ItemStyle CssClass="ibn-propertysheet"></ItemStyle>
								<HeaderStyle CssClass="text"></HeaderStyle>
								<Columns>
									<asp:BoundColumn DataField="UserId" Visible="False"></asp:BoundColumn>
									<asp:TemplateColumn HeaderText='Name' ItemStyle-Width="190" HeaderStyle-Width="190">
										<ItemTemplate>
											<%# GetLink( (int)DataBinder.Eval(Container.DataItem, "UserId"),false )%>
										</ItemTemplate>
									</asp:TemplateColumn>
									<asp:TemplateColumn HeaderText='Can Manage' ItemStyle-Width="60" HeaderStyle-Width="60">
										<ItemTemplate>
											<input type="checkbox" checked='<%# (bool)DataBinder.Eval(Container.DataItem, "CanManage") %>' class="text" runat="server" id="icCanManage" NAME="icCanManage"/>
										</ItemTemplate>
									</asp:TemplateColumn>
									<asp:TemplateColumn HeaderText='Status' ItemStyle-Width="50" HeaderStyle-Width="50">
										<ItemTemplate>
											<%# GetStatus
											(
											DataBinder.Eval(Container.DataItem, "MustBeConfirmed"),
											DataBinder.Eval(Container.DataItem, "ResponsePending"),
											DataBinder.Eval(Container.DataItem, "IsConfirmed")
											)%>
										</ItemTemplate>
									</asp:TemplateColumn>
									<asp:templatecolumn Visible="True" ItemStyle-HorizontalAlign="Center">
										<itemtemplate>
											<asp:imagebutton id="ibDelete" runat="server" borderwidth="0" width="16" height="16" imageurl="../layouts/images/DELETE.GIF" commandname="Delete" causesvalidation="False"></asp:imagebutton>
										</itemtemplate>
									</asp:templatecolumn>
								</Columns>
							</asp:DataGrid>
							<!-- End Data GRID --></div>
					</td>
				</tr>
			</table>
			<script language=javascript>
				function FuncSave()
				{
					DisableButtons(document.forms[0].<%=btnSave.ClientID%>);
					<%=Page.GetPostBackClientEvent(btnSave,"") %>;
				}
			</script>
		</form>
	</body>
</HTML>
