<%@ Reference Control="~/Modules/DateTimeClientControl.ascx" %>
<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Wizards.Modules.NewProjectWizard" Codebehind="NewProjectWizard.ascx.cs" %>
<%@ Register TagPrefix="ibn" TagName="DTCC" src="..\..\Modules\DateTimeClientControl.ascx" %>
<%@ register TagPrefix="lst" namespace="Mediachase.UI.Web.Modules" Assembly="Mediachase.UI.Web" %>
<asp:panel id="step1" Runat="server">
	<DIV class=text><%=LocRM.GetString("s1TopText") %></DIV>
	<BR>
	<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
		<TR>
			<TD vAlign=top width="50%">
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 3px"><%=LocRM.GetString("s1ProjectTitle") %></DIV>
				<asp:TextBox id=tbTitle Runat="server" Width="260"></asp:TextBox>
				<asp:RequiredFieldValidator id=s1rfTitle Runat="server" Display="Dynamic" ErrorMessage="*" ControlToValidate="tbTitle"></asp:RequiredFieldValidator>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px"><%=LocRM.GetString("s1ProjectType") %></DIV>
				<asp:DropDownList id=ddType Runat="server" Width="260"></asp:DropDownList>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 5px"><%=LocRM.GetString("s1Priority") %></DIV>
				<asp:DropDownList id="ddPriority" Runat="server" Width="260"></asp:DropDownList>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px"><%=LocRM.GetString("s1Phase") %></DIV>
				<asp:DropDownList id="ddPhase" Runat="server" Width="260"></asp:DropDownList>
			</TD>
			<TD vAlign=top align=middle width=60><IMG alt="" src="../layouts/images/quicktip.gif" border=0>
			</TD>
			<TD class=text style="PADDING-RIGHT: 15px" vAlign=top><%=LocRM.GetString("s1QuickTip") %></TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step2" Runat="server">
	<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
		<TR>
			<TD vAlign=top width="50%">
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 3px"><%=LocRM.GetString("s2StartDate") %></DIV>
				<ibn:DTCC id="dtcStartDate" Path_Img="../Layouts/Images/" Path_JS="../Scripts/" File_JS="mcCalendScript.js" SelectionDateType="Day" ViewStartDate="True" RequiredField="True" runat="server"></ibn:DTCC>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 10px"><%=LocRM.GetString("s2EndDate") %></DIV>
				<ibn:DTCC id="dtcEndDate" Path_Img="../Layouts/Images/" Path_JS="../Scripts/" File_JS="mcCalendScript.js" SelectionDateType="Day" ViewStartDate="True" RequiredField="True" runat="server"></ibn:DTCC><asp:customvalidator id="CustomValidator1" runat="server" Display="Dynamic" ErrorMessage="Wrong Date"></asp:customvalidator>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-TOP: 10px; PADDING-BOTTOM: 10px"><%=LocRM.GetString("ProjectCurrency") %>:</DIV>
				<asp:DropDownList id=ddCurrency Runat="server" Width="260"></asp:DropDownList>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 5px; PADDING-TOP: 10px"><%=LocRM.GetString("s2Executive") %></DIV>
				<asp:DropDownList id=ddExecutive Runat="server" Width="260"></asp:DropDownList>
				<DIV class=subHeader><%=LocRM.GetString("s2ExecutiveComment") %></DIV>
				</TD>
			<TD vAlign=top align=middle width=60><IMG alt="" src="../layouts/images/quicktip.gif" border=0>
			</TD>
			<TD class=text style="PADDING-RIGHT: 15px" vAlign=top><%=LocRM.GetString("s2QuickTip") %></TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step3" Runat="server">
	<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
		<TR>
			<TD vAlign=top width="50%">
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 10px; PADDING-TOP: 3px"><%=LocRM.GetString("s3Category") %></DIV>
				<asp:ListBox id=lbCategories Width="260px" runat="server" Rows="6" SelectionMode="Multiple"></asp:ListBox>
				<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 2px; PADDING-BOTTOM: 5px; PADDING-TOP: 10px"><%=LocRM.GetString("s3Portfolio") %></DIV>
				<asp:ListBox ID="lbPortfolios" Width="260px" Runat=server Rows="6" SelectionMode="Multiple"></asp:ListBox>
			</TD>
			<TD vAlign=top align=middle width=60><IMG alt="" src="../layouts/images/quicktip.gif" border=0>
			</TD>
			<TD class=text style="PADDING-RIGHT: 15px" vAlign=top><%=LocRM.GetString("s3QuickTip") %></TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step4" Runat="server">
	<DIV class=text><IMG height=20 src="../layouts/images/help.gif" width=20 align=left>
		<%=LocRM.GetString("s4TopText") %>
	</DIV>
	<BR>
	<TABLE class="text" style="HEIGHT: 100%" height="100%" cellSpacing=0 cellPadding=3 width="100%" border=0>
		<TR height=22>
			<TD class="boldtext" width=350 height=22><%=LocRM.GetString("s4Selected") %>:</TD>
			<TD width=4>&nbsp;</TD>
			<TD class=boldtext><%=LocRM.GetString("s4Available") %>:</TD>
		</TR>
		<TR style="HEIGHT: 100%">
			<TD vAlign=top width=350 height="100%"><!-- Data GRID -->
				<DIV style="OVERFLOW-Y: auto; HEIGHT: 200px">
					<asp:DataGrid id=dgMembers Runat="server" Width="100%" borderwidth="0px" CellSpacing="0" gridlines="None" cellpadding="0" AllowSorting="False" AllowPaging="False" AutoGenerateColumns="False">
						<ItemStyle CssClass="text"></ItemStyle>
						<HeaderStyle CssClass="text"></HeaderStyle>
						<Columns>
							<asp:BoundColumn DataField="UserId" Visible="False"></asp:BoundColumn>
							<asp:TemplateColumn HeaderText='Name'>
								<ItemTemplate>
									<%# Mediachase.UI.Web.Util.CommonHelper.GetUserStatusUL((int)DataBinder.Eval(Container.DataItem, "UserId"))%>
								</ItemTemplate>
							</asp:TemplateColumn>
							<asp:TemplateColumn HeaderText='Code' itemstyle-width="50">
								<ItemTemplate>
									<input type="text" class="text" runat="server" value='<%# DataBinder.Eval(Container.DataItem, "Code") %>' id="tCode"  maxlength="2" style="Width:30px" NAME="tCode"/>
									<asp:RequiredFieldValidator ID="vCode" Runat="server" ControlToValidate="tCode" ErrorMessage="*" Display="Dynamic"></asp:RequiredFieldValidator>
								</ItemTemplate>
							</asp:TemplateColumn>
							<asp:TemplateColumn HeaderText='Rate' itemstyle-width="70">
								<ItemTemplate>
									<input type="text" class="text" runat="server" value='<%# DataBinder.Eval(Container.DataItem, "Rate") %>' id="tRate"  style="Width:50px" NAME="tRate"/>
									<asp:RequiredFieldValidator ID="Requiredfieldvalidator1" Runat="server" ControlToValidate="tRate" ErrorMessage="*" Display="Dynamic"></asp:RequiredFieldValidator>
									<asp:RangeValidator Type="Integer" MinimumValue="0" MaximumValue="100000" ID="Requiredfieldvalidator2" Runat="server" ControlToValidate="tRate" ErrorMessage="*" Display="Dynamic" />
								</ItemTemplate>
							</asp:TemplateColumn>
							<asp:templatecolumn itemstyle-width="30" Visible="True">
								<itemtemplate>
									<asp:imagebutton id="ibDelete" runat="server" borderwidth="0" width="16" height="16" imageurl="../../layouts/images/DELETE.GIF" commandname="Delete" causesvalidation="False"></asp:imagebutton>
								</itemtemplate>
							</asp:templatecolumn>
						</Columns>
					</asp:DataGrid><!-- End Data GRID --></DIV>
			</TD>
			<TD width=4>&nbsp;</TD>
			<TD vAlign=top><!-- Groups & Users -->
				<TABLE class=text style="MARGIN-TOP: 5px" cellSpacing=0 cellPadding=3 width="100%">
					<TR>
						<TD style="HEIGHT: 18px" width="9%"><%=LocRM.GetString("s4Group") %>:</TD>
						<TD style="HEIGHT: 18px" width="91%">
							<LST:INDENTEDDROPDOWNLIST id=ddGroups Width="190px" runat="server" DataValueField="GroupId" DataTextField="GroupName" AutoPostBack="True" CssClass="text" onselectedindexchanged="ddGroups_ChangeGroup"></LST:INDENTEDDROPDOWNLIST></TD>
					</TR>
					<TR>
						<TD width="9%"><%=LocRM.GetString("s4Search") %>:</TD>
						<TD width="91%">
							<asp:TextBox id=tbSearch Width="125px" runat="server" CssClass="text"></asp:TextBox>
							<asp:button id=btnSearch Width="60px" runat="server" CssClass="text" CausesValidation="False" onclick="btnSearch_Click"></asp:button></TD>
					</TR>
					<TR>
						<TD vAlign=top height=96><%=LocRM.GetString("s4User") %>:</TD>
						<TD vAlign=top>
							<asp:listbox id=lbUsers Width="190px" runat="server" Rows="6" SelectionMode="Multiple" CssClass="text"></asp:listbox></TD>
					</TR>
					<TR>
						<TD vAlign=top height=28>&nbsp;</TD>
						<TD><BUTTON class=text id=btnAdd style="WIDTH: 90px" type=button runat="server" onserverclick="btnAdd_Click"></BUTTON>
							<asp:Button id=btnSave style="DISPLAY: none" runat="server" Text="Button"></asp:Button></TD>
					</TR>
				</TABLE> <!-- End Groups & Users --></TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step5" Runat="server">
	<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
		<TR>
			<TD vAlign=top>
				<TABLE class=text cellSpacing=3 cellPadding=3 width="100%" border=0>
					<TR>
						<TD><%=LocRM.GetString("s5Description") %></TD>
					</TR>
					<TR>
						<TD>
							<asp:textbox class=text id=txtDescription Width="260px" runat="server" CssClass="text" TextMode="MultiLine" Height="105px"></asp:textbox></TD>
					</TR>
					<TR>
						<TD><%=LocRM.GetString("s5Scope") %></TD>
					</TR>
					<TR>
						<TD>
							<asp:textbox id=txtScope Width="260px" runat="server" CssClass="text" TextMode="MultiLine" Height="105px" DESIGNTIMEDRAGDROP="1295"></asp:textbox></TD>
					</TR>
				</TABLE>
			</TD>
			<TD vAlign=top>
				<TABLE class=text cellSpacing=3 cellPadding=3 width="100%" border=0>
					<TR>
						<TD><%=LocRM.GetString("s5Goals") %></TD>
					</TR>
					<TR>
						<TD>
							<asp:textbox id=txtGoals Width="260px" runat="server" CssClass="text" TextMode="MultiLine" Height="105px"></asp:textbox></TD>
					</TR>
					<TR>
						<TD><%=LocRM.GetString("s5Deliverables") %></TD>
					</TR>
					<TR>
						<TD>
							<asp:textbox id=txtDeliverables Width="260px" runat="server" CssClass="text" TextMode="MultiLine" Height="105px"></asp:textbox></TD>
					</TR>
				</TABLE>
			</TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step6" Runat="server" Visible="False">
	<DIV class=text><IMG height=20 src="../layouts/images/help.gif" width=20 align=absMiddle>
		&nbsp;<%=LocRM.GetString("s6TopText") %>
	</DIV>
	<BR>
	<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
		<TR>
			<TD vAlign=top width="50%">
				<TABLE cellSpacing=0 cellPadding=0 width="100%" border=0>
					<TR>
						<TD vAlign=top>
							<TABLE class=subHeader cellSpacing=0 cellPadding=5 width="100%" border=0>
								<TR>
									<TD width=100><B><%=LocRM.GetString("s6Project") %>:</B>
									</TD>
									<TD>
										<asp:Label id=lblProjectTitle Runat="server"></asp:Label></TD>
								</TR>
								<TR>
									<TD><B><%=LocRM.GetString("s6StartDate") %>:</B>
									</TD>
									<TD>
										<asp:Label id=lblStartDate Runat="server"></asp:Label></TD>
								</TR>
								<TR>
									<TD><B><%=LocRM.GetString("s6EndDate") %>:</B>
									</TD>
									<TD>
										<asp:Label id=lblEndDate Runat="server"></asp:Label></TD>
								</TR>
								<TR>
									<TD><B><%=LocRM.GetString("s6ProjectType") %>:</B>
									</TD>
									<TD>
										<asp:Label id=lblType Runat="server"></asp:Label></TD>
								</TR>
								<TR>
									<TD><B><%=LocRM.GetString("s6Executive") %>:</B>
									</TD>
									<TD>
										<asp:Label id=lblExecutive Runat="server"></asp:Label></TD>
								</TR>
							</TABLE>
						</TD>
						<TD vAlign=top width=200>
							<DIV class=subHeader style="PADDING-RIGHT: 0px; PADDING-LEFT: 0px; PADDING-BOTTOM: 10px; PADDING-TOP: 3px"><B><%=LocRM.GetString("s6Team") %>:</B></DIV>
							<div style="OVERFLOW-Y:auto;height:120px;">
							<asp:DataList id=dlTeam Runat="server" CssClass="subTitle">
								<ItemTemplate>
									<%# Mediachase.UI.Web.Util.CommonHelper.GetUserStatusUL((int)DataBinder.Eval(Container.DataItem, "UserId"))%>
								</ItemTemplate>
							</asp:DataList>
							</div>
							<asp:CheckBox id=cbNotify Runat="server" CssClass="cb"></asp:CheckBox></TD>
					</TR>
					<TR>
						<TD colSpan=2>
							<TABLE class=subHeader cellSpacing=0 cellPadding=5 width="100%" border=0>
								<TR>
									<TD width=100><B><%=LocRM.GetString("s6Description") %>:</B></TD>
									<TD><asp:Label id=lblDescription Runat="server"></asp:Label></TD>
								</TR>
							</TABLE>
						</TD>
					</TR>
				</TABLE>
			</TD>
		</TR>
	</TABLE>
</asp:panel><asp:panel id="step7" Runat="server" Visible="False">
	<DIV class=text><IMG height=20 src="../layouts/images/help.gif" width=20 align=absMiddle>&nbsp;<%=LocRM.GetString("s7TopText") %></DIV>
	<BR>
	<DIV class=SubHeader><B></B><BR>
		<BR>
	</DIV>
	<DIV class=SubHeader style="PADDING-LEFT: 20px"><%=LocRM.GetString("s7Text") %></DIV>
</asp:panel>
