<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Page language="c#" Inherits="Mediachase.UI.Web.Admin.EMailIssueRuleEdit" Codebehind="EMailIssueRuleEdit.aspx.cs" %>
<%@ register TagPrefix="mc" namespace="Mediachase.UI.Web.Modules" Assembly="Mediachase.UI.Web" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="..\Modules\BlockHeader.ascx" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" > 

<html>
  <head>
    <title><%=sTitle%></title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<link href='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Layouts/Styles/dialog.css")%>' rel="stylesheet" type="text/css">
	<link href='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Layouts/Styles/ibn.css")%>' rel="stylesheet">
	<LINK href='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Layouts/Styles/windows.css")%>' type="text/css" rel="stylesheet">
	<LINK href='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Layouts/Styles/mcCalendClient.css")%>' rel="stylesheet">
	<script src='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Scripts/buttons.js")%>'></script>
	<script src='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Scripts/browser.js")%>'></script>
	<script src='<%=Mediachase.UI.Web.Util.CommonHelper.GetAbsolutePath("/Scripts/List2List.js")%>'></script>
	<script language="javascript">
			function disableEnterKey() 
			{ 
				try {
					if (window.event.keyCode == 13 && window.event.srcElement.type != "textarea")
						window.event.keyCode = 0;
				}
				catch (e) {}
			}
	</script>
  </head>
  <body leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0" style="margin:0px;background-color:#ffffff">
	
    <mc:FixedForm id="frmMain" method="post" runat="server" onkeypress="disableEnterKey()" bgcolor="#ece9d8" enctype="multipart/form-data">
<TABLE class="ibn-stylebox2" cellSpacing="0" cellPadding="0" width="100%" border="0">
	<tr>
		<td><ibn:blockheader id="secHeader" runat="server" /></td>
	</tr>
	<tr>
		<td>
			<table border="0" cellpadding="7" cellspacing="0" width="100%" class="text ibn-alternating ibn-navline">
				<tr>
					<td width="75px"><b><%=LocRM.GetString("tType")%>:</b></td>
					<td><asp:DropDownList ID="ddRuleType" Runat="server" AutoPostBack="True" Width="250px"></asp:DropDownList></td>
				</tr>
			</table>
			
			<table border="0" cellpadding="7" cellspacing="0" width="95%" class="text" id="tblMain" runat="server">
				<tr>
					<td width="80px" valign="top" style="padding-top:10"><b><%=LocRM.GetString("tKey")%>:</b></td>
					<td width="260px" valign="top">
						<asp:DropDownList ID="ddKey" Runat="server" Width="250px"></asp:DropDownList>
						<asp:DataGrid Runat="server" ID="dgParams" AutoGenerateColumns="False" 
							AllowPaging="False" AllowSorting="False" cellpadding="5" 
							gridlines="None" CellSpacing="0" borderwidth="0px" Width="250px" 
							ShowHeader="True">
							<Columns>
								<asp:BoundColumn DataField="Position" Visible="False"></asp:BoundColumn>
								<asp:TemplateColumn>
									<ItemStyle CssClass="ibn-vb2" Width="110px"></ItemStyle>
									<ItemTemplate>
										<%# DataBinder.Eval(Container.DataItem, "Name")%>
									</ItemTemplate>
								</asp:TemplateColumn>
								<asp:TemplateColumn>
									<ItemStyle CssClass="ibn-vb2"></ItemStyle>
									<ItemTemplate>
										<asp:TextBox ID="tbValue" Runat="server" Text='<%# DataBinder.Eval(Container.DataItem, "DefaultValue")%>' Width="110px"></asp:TextBox>
										<asp:RequiredFieldValidator ID="rfFunc" Runat="server" ControlToValidate="tbValue" Display="Dynamic" ErrorMessage="*"></asp:RequiredFieldValidator>
									</ItemTemplate>
								</asp:TemplateColumn>
							</Columns>
						</asp:DataGrid>
					</td>
					<td>&nbsp;</td>
				</tr>
				<tr id="trOperator" runat="server">
					<td>&nbsp;</td>
					<td><asp:DropDownList ID="ddOperator" Runat="server" Width="250px"></asp:DropDownList></td>
				</tr>
				<tr id="trValue" runat="server">
					<td valign="top" style="padding-top:10px"><b><%=LocRM.GetString("tValue")%>:</b></td>
					<td valign="top"><asp:TextBox ID="txtValue" Runat="server" Width="250px"></asp:TextBox>
					<asp:DropDownList ID="ddEmailBoxes" Runat="server" Width="250px"></asp:DropDownList>
					<asp:DropDownList ID="ddCreator" Runat="server" Width="250px"></asp:DropDownList>
					<asp:DropDownList ID="ddProject" Runat="server" Width="250px"></asp:DropDownList>
					<asp:DropDownList ID="ddType" Runat="server" Width="250px"></asp:DropDownList>
					<asp:DropDownList ID="ddPriority" Runat="server" Width="250px"></asp:DropDownList>
					<asp:DropDownList ID="ddSeverity" Runat="server" Width="250px"></asp:DropDownList>
					<asp:ListBox ID="lbGenCats" Runat="server" Width="250px" Rows="4" SelectionMode="Multiple"></asp:ListBox>
					<asp:ListBox ID="lbIssCats" Runat="server" Width="250px" Rows="4" SelectionMode="Multiple"></asp:ListBox>
					</td>
					<td><asp:Label ID="lblValueError" Runat="server" CssClass="text" ForeColor="#ff0000"></asp:Label>&nbsp;</td>
				</tr>
				<tr>
					<td><b><%=LocRM.GetString("tIndex")%>:</b></td>
					<td><asp:DropDownList ID="ddIndex" Runat="server" Width="50px"></asp:DropDownList></td>
					<td>&nbsp;</td>
				</tr>
				<tr height="50px" valign="bottom">
					<td align="right" style="padding-right:10px" colspan="3">
						<mc:ImButton runat="server" class="text"  ID="imbSave" CustomImage="../layouts/images/saveitem.gif" style="width:105px"></mc:ImButton>&nbsp;
						<mc:ImButton runat="server" class="text" ID="imbCancel" CustomImage="../layouts/images/cancel.gif" onclick="javascript:window.close();" style="width:105px" CausesValidation="false"></mc:ImButton>
					</td>
				</tr>
			</table>
			<div style="padding:10 10 0 95;">
			<asp:Label ID="lblNoFunction" Runat="server" CssClass="text" ForeColor="red"></asp:Label>
			</div>
		</td>
	</tr>
</table>
		<script language="javascript">
			function ChangeKey(obj)
			{
				var _lbl = document.getElementById('<%=lblValueError.ClientID%>');
				var _val = document.getElementById('<%=txtValue.ClientID%>');
				var _boxes = document.getElementById('<%=ddEmailBoxes.ClientID%>');
				var _creat = document.getElementById('<%=ddCreator.ClientID%>');
				var _prj = document.getElementById('<%=ddProject.ClientID%>');
				var _type = document.getElementById('<%=ddType.ClientID%>');
				var _prior = document.getElementById('<%=ddPriority.ClientID%>');
				var _sever = document.getElementById('<%=ddSeverity.ClientID%>');
				var _gencats = document.getElementById('<%=lbGenCats.ClientID%>');
				var _isscats = document.getElementById('<%=lbIssCats.ClientID%>');
				
				_lbl.style.display = "none";
				_val.style.display = "";
				_boxes.style.display = "none";
				_creat.style.display = "none";
				_prj.style.display = "none";
				_type.style.display = "none";
				_prior.style.display = "none";
				_sever.style.display = "none";
				_gencats.style.display = "none";
				_isscats.style.display = "none";
				
				var _oper = document.getElementById('<%=ddOperator.ClientID%>');
				var old_value = _oper.value;
				DeleteAll(_oper);
				
				if(obj.value=="EMailBox")
				{
					_val.style.display = "none";
					_boxes.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="CreatorId")
				{
					_val.style.display = "none";
					_creat.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="ProjectId")
				{
					_val.style.display = "none";
					_prj.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="TypeId")
				{
					_val.style.display = "none";
					_type.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="PriorityId")
				{
					_val.style.display = "none";
					_prior.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="SeverityId")
				{
					_val.style.display = "none";
					_sever.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="GeneralCategories")
				{
					_val.style.display = "none";
					_gencats.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.Contains)%>', '0');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotContains)%>', '7');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else if(obj.value=="IncidentCategories")
				{
					_val.style.display = "none";
					_isscats.style.display = "";
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.Contains)%>', '0');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotContains)%>', '7');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				else
				{
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.Contains)%>', '0');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotContains)%>', '7');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.RegexMatch)%>', '1');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.IsEqual)%>', '2');
					AddOption2(_oper, '<%=GetRuleType(Mediachase.IBN.Business.EMail.IncidentBoxRuleType.NotIsEqual)%>', '8');
				}
				if(CheckExistenceValue(_oper, old_value))
					_oper.value = old_value;
			}
			function ChangeKey2(sId)
			{
				var obj = document.getElementById(sId);
				if(obj)
					ChangeKey(obj);
			}
		</script>
    </mc:FixedForm>
	
  </body>
</html>
