<%@ Control Language="c#" Inherits="Mediachase.UI.Web.Admin.Modules.AdminReports" Codebehind="AdminReports.ascx.cs" %>
<%@ Reference Control="~/Modules/Separator1.ascx" %>
<%@ Reference Control="~/Modules/BlockHeader.ascx" %>
<%@ Reference Control="~/Modules/DateTimeClientControl.ascx" %>
<%@ Register TagPrefix="ibn" TagName="sep" src="~/Modules/Separator1.ascx"%>
<%@ Register TagPrefix="ibn" TagName="ErrorLog" src="ErrorLog.ascx" %>
<%@ Register TagPrefix="ibn" TagName="BlockHeader" src="~/Modules/BlockHeader.ascx"%>
<%@ Register TagPrefix="ibn" TagName="DTCC" src="~/Modules/DateTimeClientControl.ascx" %>

<script language="javascript" type="text/javascript">
function ClearLog()
{
	if(confirm('<%=LocRM.GetString("tClearErrorLog")%>'+'?'))
	{
		<%= Page.GetPostBackClientEvent(lbtnClearLog, "")%>
	}
}
</script>

<table class="ibn-stylebox2" cellspacing="0" cellpadding="0" width="100%" border="0" runat="server" id="tableStat">
	<tr>
		<td>
			<ibn:BlockHeader id="Header3" title='<%#LocRM.GetString("QuickInformation")%>' runat="server" />
		</td>
	</tr>
	<tr>
		<td style="padding:0px;">
			<table border="0" cellpadding="0" cellspacing="0" width="100%">
				<tr>
					<td valign="top">
						<table class="text" cellspacing="0" cellpadding="3" border="0" width="100%">
							<tr>
								<td colspan="2" style="PADDING:0px">
									<ibn:sep width="100%" id="Sep1" runat="server" title='<%#LocRM.GetString("UserAndGroupStats")%>' IsClickable="false" />
								</td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("TotalUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblTotalUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("TotalGroups")%>:</td>
								<td class="ibn-label"><asp:label id="lblTotalGroups" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td colspan="2" class="ibn-vb2" height="1" style="padding:0px"><img src="../layouts/images/blank.gif" /></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("SecureGroups")%>:</td>
								<td class="ibn-label"><asp:label id="lblSecureGroups" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("PartnerGroups")%>:</td>
								<td class="ibn-label"><asp:label id="lblPartnerGroups" Runat="server"></asp:label></td>
							</tr>
							<tr id="trIMBlock0" runat="server">
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("ContactGroups")%>:</td>
								<td class="ibn-label"><asp:label id="lblContactGroups" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td colspan="2" class="ibn-vb2" height="1" style="padding:0px"><img src="../layouts/images/blank.gif" /></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("ActiveUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblActiveUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("DisabledUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblDisabledUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td colspan="2" class="ibn-vb2" height="1" style="padding:0px"><img src="../layouts/images/blank.gif" /></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("PartnerUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblPartnerUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("RegularUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblRegularUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("ExternalUsers")%>:</td>
								<td class="ibn-label"><asp:label id="lblExternalUsers" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td colspan="2" style="PADDING:0px">
									<ibn:sep width="100%" id="Sep2" runat="server" title='<%#LocRM.GetString("AccessUsageStats")%>' IsClickable="false" />
								</td>
							</tr>
							<tr id="trIMBlock1" runat="server">
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("IMLoginCount")%>:</td>
								<td class="ibn-label"><asp:label id="lblIMLoginCount" Runat="server"></asp:label></td>
							</tr>
							<tr>
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("PortalLoginCount")%>:</td>
								<td class="ibn-label"><asp:label id="lblPortalCount" Runat="server"></asp:label></td>
							</tr>
							<tr id="trIMBlock2" runat="server">
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("MessagesSent")%>:</td>
								<td class="ibn-label"><asp:label id="lblMessagesSent" Runat="server"></asp:label></td>
							</tr>
							<tr id="trIMBlock3" runat="server">
								<td width="200px" style="padding-left:10px"><%=LocRM.GetString("MessagesReceived")%>:</td>
								<td class="ibn-label"><asp:label id="lblMessagesReceived" Runat="server"></asp:label></td>
							</tr>
						</table>
					</td>
					<td valign="top" runat="server" id="tdStatusLog" style="border-left: solid 1px #C2C2C2; width: 400px;">
						<table class="text" cellspacing="0" cellpadding="3" border="0" width="100%">
							<tr>
								<td colspan="2" style="padding:0px;">
									<ibn:sep width="100%" id="Sep3" runat="server" title='<%#LocRM.GetString("StatusLog")%>' IsClickable="false" />
									<br />
								</td>
							</tr>
							<tr>
								<td style="padding-left:10px; width:100px"><%=LocRM.GetString("Group")%>:</td>
								<td class="ibn-label">
									<asp:DropDownList runat="server" ID="ddlGroup" Width="250" OnSelectedIndexChanged="ddlGroup_SelectedIndexChanged" AutoPostBack="true"></asp:DropDownList>
								</td>
							</tr>
							<tr>
								<td style="padding-left:10px; width:100px"><%=LocRM.GetString("User")%>:</td>
								<td class="ibn-label">
									<asp:DropDownList runat="server" ID="ddlUser" Width="250"></asp:DropDownList>
								</td>
							</tr>
							<tr>
								<td style="padding-left:10px; width:100px"><%=LocRM.GetString("From")%>:</td>
								<td class="ibn-label">
									<ibn:DTCC id="fromDate" ShowTime="HM" TimeSpin="True" Minutes_Step="5" Drop_gAlign="center" Path_Img="../Layouts/Images/" Path_JS="../Scripts/" File_JS="mcCalendScript.js" SelectionDateType="Day" ViewStartDate="True" RequiredField="True" runat="server"></ibn:DTCC>
								</td>
							</tr>
							<tr>
								<td style="padding-left:10px; width:100px"><%=LocRM.GetString("To")%>:</td>
								<td class="ibn-label">
									<ibn:DTCC id="toDate" ShowTime="HM" TimeSpin="True" Minutes_Step="5" Drop_gAlign="center" Path_Img="../Layouts/Images/" Path_JS="../Scripts/" File_JS="mcCalendScript.js" SelectionDateType="Day" ViewStartDate="True" RequiredField="True" runat="server"></ibn:DTCC>
								</td>
							</tr>
							<tr>
								<td></td>
								<td>
									<asp:Button runat="server" ID="btnGenerate" OnClick="btnGenerate_Click" />
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
<table class="ibn-stylebox2" cellspacing="0" cellpadding="0" width="100%" border="0" runat="server" id="tableErrors">
	<tr>
		<td>
			<ibn:BlockHeader id="Header2" title='<%#LocRM.GetString("QuickInformation")%>' runat="server" />
		</td>
	</tr>
	<tr>
		<td style="PADDING-RIGHT:5px;PADDING-BOTTOM:5px">
			<ibn:ErrorLog runat="server" id="ErrorLog1"></ibn:ErrorLog>
			<asp:LinkButton runat="server" ID="lbtnClearLog" Visible="false"></asp:LinkButton>
		</td>
	</tr>
</table>
